package jade.db;

import java.io.*;
import java.util.*;

//===================================================================================
// AceString is a utility class for parsing raw text from the database.  
// It should be improved.
//===================================================================================
class AceString {

  private String rawString="";
  private String theClass="";
  private String theID="";

  AceString(String theString) {
	rawString = theString;
  }  
   String aceClass() {
	 if (theClass.length() == 0)
	   findClass();
	 return theClass;
   }   
   String aceID() {
	 if (theID.length() == 0)
	   findClass();
	 return theID;
   }   
  // Count the number of leading tabs
   int countTabs() {
	 int tabs = 0;

	 for (int i = 0; i < rawString.length(); i++) {
	   if (rawString.charAt(i) != '\t')
	 break;
	   tabs++;
	 }
	 return tabs;

   }   
  private void findClass() {
	String[] parts = split('?',true);
	if (parts.length > 1)
	  theClass = parts[1];
	if (parts.length > 2)
	  theID = parts[2];
  }  
  /* split a string into pieces on the provided character
	 and unescapes escaped characters.
	 This is somewhat specialized to deal with ACE strings, so
	 don't expect it to work in the general case.  */
  String[] split (char splitChar) {
	return split(splitChar,false);
  }  
  String[] split (char splitChar,boolean unescape) {
	Vector contents = new Vector(20);

	/* allocate a working buffer that is large enough to
	   receive the entire string if necessary */
	char raw[] = rawString.toCharArray();
        //System.out.println(rawString);  //wgm
	char buffer[] = new char[raw.length];
	int j=0, i=0;

	while (i<raw.length) {
	  
	  /* first we handle all the nasty escape sequences */
	  if (unescape && (raw[i] == '\\') && (i<raw.length-2)) {
	char theChar;
	i++;
	switch (raw[i]) {
	  case 'n':
	    theChar = '\n';
	    break;
	  case 't':
	    theChar = '\t';
	    break;
	  case 'r':
	    theChar = '\r';
	    break;
	default:
	  theChar = raw[i];
	}
	buffer[j++] = theChar;
	  } else if (raw[i] == splitChar) {
	contents.addElement(String.copyValueOf(buffer,0,j));
       	j = 0;
	  } else {
	/* otherwise we continue to grow the buffer */
	buffer[j++]=raw[i];
	  }
	  i++;
	}
	if (j > 0)
	  contents.addElement(String.copyValueOf(buffer,0,j));    
	
	String[] result = new String[contents.size()];
	for (i = 0; i < contents.size(); i++)
	  result[i] = (String)contents.elementAt(i);

	return result;
  }  
  public String toString() {
	 return rawString;
  }  
}