/*
 * JSAceAccessor.java
 * By subclassing AceAccessor, JSAceSccessor is implemented as Accessor to the socket of
 * AceDB server. Almost all low level communication methods have been rewitten.
 *
 * Created on June 28, 2000, 2:59 PM
 */

package jade.db;

import java.io.*;
import java.net.*;
import java.util.*;

import jadeSocket.*;

/**
 *
 * @author  wgm
 * @version
 */
public class JSAceAccessor extends AceAccessor {

  private JSControl control = null; // Control for JSAceClient
  //private AceCache cache = null;

  private boolean debug = false;
  private boolean debug1 = false;

  /** Main method is used to check the interfaces of this classes.
   */
  public static void main (String args[]) {
    if (args.length != 2) {
      System.out.println("Usage: java JSAceAccessot host port");
      System.exit(0);
    }
    String host = args[0];
    int port = Integer.parseInt(args[1]);
    JSAceAccessor movie = new JSAceAccessor(host, port);
    //movie.count("person", "*");
    //AceObject woo = movie.fetch("person", "woo");
    //woo.fill();
    //System.out.println("********* Dump AceObject *********** start");
    //System.out.println("JSAceAccessor dump: " + woo.dump());
    //System.out.println("********* Dump AceObject *********** end");

    //System.out.println("********* Follow AceObject *********** start");
    //AceObject[] objects = worm.find("person", "w*");
    //AceObject objects[] = movie.follow("person", "stone1", "Stars_in");
    //System.out.println("JSAceAccessor found number: " + objects.length);
    //for (int i = 0; i < objects.length; i ++)
    //  System.out.println(objects[i].name);

    //System.out.println("********* Follow AceObject *********** end");

    //worm.classes();

    System.out.println("********* TableQuery *********** start");
    String [] params = {"I"};
    /*Object[][] table = movie.getTable("map.point", params, "sss");
    for (int i = 0; i < table.length; i++) {
      for (int j = 0; j < table[i].length; j++) 
        System.out.print(table[i][j].toString() + "     " + j);
      System.out.println();
    }*/
    AceTable table = movie.tableQuery("map.point", params);
    System.out.println("TableQuery classes: " + table.dump());
    System.out.println("Col: " + table.colCount());
    System.out.println("Row: " + table.rowCount());
    System.out.println("********* TableQuery *********** end");

    //System.out.println("********* TableQuery: Create table on the fly---Start");
    //String[] querys = {"Sortcolumn 1", "Colonne 1", "Width 12", "Optional", "Visible", "Class", "Class Class",
    //"From 1", "Colonne 2", "Width 12", "Mandatory", "Visible", "Show_Tag", "From 1", "Tag Visibility"};
    //AceTable table1 = movie.tableQuery(querys);
    //System.out.println("Another tableQuery: " + table1.dump());
    //System.out.println("********** TableQuery: Creat table on  the fly---End");
  }

  /** Creates new JSAceAccessor */
  public JSAceAccessor(String host,int port) {
    super();
    control = new JSControl(host, port);
    control.initializeRequest("guest", "guest");
    super.cache = new AceCache(super.CACHE_MIN, super.CACHE_MAX);
  }

  /** active objects counting */
  protected synchronized int countRequest(String query) {
    String result;
    int resultCode;
    write(query);
    result = read();
    return foundCount(result);
  }

  /** Parsing the active object number */
  protected int foundCount(String result) {
    int number = 0;
    if (debug) System.out.println("JSAceAccessor: " + result);
    int pos = result.indexOf("Active Objects");
    int last = result.lastIndexOf("//");
    try {
      number = Integer.parseInt(result.substring(last+2, pos).trim());
    }
  catch (NumberFormatException e) { return -1; }
    if (debug) System.out.println("JSAceAccessor: " + number);
    return number;
  }

  /** for public method fetch in the superclass */
  protected synchronized AceObject low_fetch(String classe,String name,boolean fill) {
    int count = count(classe,name);
    if (count < 0) return null;
    if (count > 1) return null;
    AceObject ace = new AceObject(classe, name, this);

    if (fill) {
      ace.fill();
    }

    return ace;
  }

  /** Filling AceObject */
  protected synchronized AceObject low_fill(AceObject a) throws IOException {
    AceObject result = null;
    if (count(a.classe,a.name) == 1) {
      write("show -j");
      String inputLine = read();
      PushBackStream in = new PushBackStream(new BufferedReader(new CharArrayReader(inputLine.toCharArray())));
      inputLine = in.readLine();
      if (debug) System.out.println("JSAceAccessor low_fill: " + inputLine);
      String[] elements = new AceString(inputLine).split('\t');
      result = new AceObject(elements,in,1,this);
      if (debug) System.out.println("JSAceAccessor low_fill: " + result);
    }
    return result;
  }

  /** Listing active objects based on start number and total number. 
   *  I hope to change this method to public.
   */
  protected synchronized AceObject[] list (int start,int length) {

    Vector objects = new Vector();
    AceObject[] result;
    //int max = (length >= 0) ? length : Integer.MAX_VALUE;
    String command = "list -j -b " + start + " -c " + length;

    write(command);
    String nextline = read();
    if (debug) System.out.println("JSAceAccessor list: " + nextline);
    String[] lines = parseString(nextline);

    if ((lines != null) && (lines.length > 0)) {

      for (int i = 0; i < lines.length; i++) {
        String line = lines[i];
        AceString a = new AceString(line);
        AceObject ao = cache.fetch(a.aceClass(),a.aceID(),true);
        if (ao == null)
        ao = new AceObject(a.aceClass(),a.aceID(),this);
        objects.addElement(ao);
      }

      int size = objects.size();
      result = new AceObject[size];
      for (int i = 0; i < size; i++) {
        result[i] = (AceObject) objects.elementAt(i);
      }

      return result;
    }
    else return null;
  }

  /** A utility to change one-line string into several lines */
  private String[] parseString(String input) {

    LineNumberReader lnr = new LineNumberReader(new CharArrayReader(input.toCharArray()));
    String line = null;
    Vector v = new Vector();
    try {
      while ((line = lnr.readLine()) != null) {
        if (line.indexOf("?") == -1) continue;
        v.addElement(line);
      }
    }
  catch (IOException e) { return null; }

    int size = v.size();
    String result[] = new String[size];
    for (int i = 0; i < size; i++)
    result[i] = (String) v.elementAt(i);

    return result;
  }

  /** Following aceobject based on tag. */
  public synchronized AceObject[] follow(String classe,String name,
  String tag,int length) {
    int objects = count(classe,name);
    if (objects != 1) return null;
    write("follow " + tag);
    return list(0,length);
  }

  /** for AceTable filling */
  protected synchronized AceObject table_fill(AceTable a) throws IOException {
    String tbString = null;

    if (a.runtime) {
      if (a.theQuery == null)
      return null;

      if ((tbString = jsTable(a.theQuery)) == null) return null;
    } else {
      if ((tbString = jsTable(a.name,a.params)) == null) return null;
    }
    if (debug) System.out.println("JSAceAccessor able_fill: " + tbString);
    PushBackStream in = new PushBackStream(new BufferedReader(new CharArrayReader(tbString.toCharArray())));
    a.initializeFromStream(in,this);

    return a.right;
  }

  /** These two methods are used to replace two table methods in the superclass. */
  protected synchronized String jsTable(String[] querys) {

    StringBuffer p = new StringBuffer("table -j =");
    int size = querys.length;
    for (int i = 0; i < size - 1; i++)
    p.append(querys[i] + "\n");
    p.append(querys[size-1]);

    write(p.toString());

    return read();
  }

  protected synchronized String jsTable(String name, String[] parameters) {
    StringBuffer p = new StringBuffer("table -j -n");
    p.append (" " + name);
    for (int i = 0; i < parameters.length; i++)
    p.append(" " + parameters[i]);
    write(p.toString());
    return read();
  }

  /** Get the visible class for Aceodel in Jadex.Swing package
   */
  public Vector classes() {

    write("class");
    String input = read();
    if (debug) System.out.println("JSAceAccessor classes: " + input);

    Vector v = new Vector();

    try {
      LineNumberReader lnr = new LineNumberReader(new CharArrayReader(input.toCharArray()));
      lnr.readLine();
      String s = null;
      while ((s = lnr.readLine()) != null) {
        if (s.length() == 0) continue;
        if (debug) System.out.println("ParseMessage in AceModel: " + s);
        if (s.indexOf("Active Object") > -1) break;
        int pos = s.lastIndexOf(" ");
        String name = s.substring(0, pos).trim();
        if (debug) System.out.println(name);

        v.addElement(name);
      }
    }
  catch(IOException e) { System.out.println(e); }

    return v;
  }

  /** Send query to the server by JSControl and JSAceClient */
  /** The access modifier has been changed to public from protected for using aql */
  public void write(String query) {
   control.request(query); 
  }

  /** Get message from the server */
  /** The access modifier has been changed to public from protected for using aql */
  public String read() {
    return control.getMessage();
  }
}