package jade.db;
import java.io.*;
import java.util.*;

// ================================================================================
// PushBackStream was written at a time before Sun had come up with their own
// pushback stream class.  Since the interface is different, it stays.
// ================================================================================

class PushBackStream {
  private BufferedReader theStream;
  private Stack theStack;

  PushBackStream(BufferedReader in) {
    theStream = in;
    theStack = new Stack();
  }

  String readLine() throws IOException {
    if (!theStack.empty())
      return (String)theStack.pop();
    else {
      // We're going to do some weird stuff to work around what I think
      // is a bug in the Java socket implementation
      String tmp = null;
      int count = 0;
      while ((count < 5) && (tmp == null)) {
	try {
	  tmp = theStream.readLine();
	} catch (IOException e) {
	  ; // just ignore the error
	} finally {
	  count++;
	}
      }
      if (tmp== null)
	throw new IOException("Repeated read failures in PushBackStream.readLine()");
      return tmp;
    }
  }

  void pushBack(String theString) {
    theStack.push(theString);
  }

}
