package jade.util;

import jade.db.*;

// Definitions for a Key (superclass of AceObject)

public class Key 
{
public String name = null;
protected Accessor axessor = null;

  // STATUS CODES for status()
public static final int INERT=0;     // this is a scalar object.  It won t pick.
public static final int DEAD=1;      // object is a class but not pickable
public static final int POTENTIAL=2; // object is a class but not yet picked
public static final int LIVE=3;      // object is a class and already picked

  // Return the status code for this object.  LIVE objects are known to be
  // pickable (retrievable classes) and are usually to be found in the
  // object cache.  POTENTIAL objects are classes that may or may not
  // be pickable.  DEAD objects are those that do not have a tree in the
  // database.  INERT objects are floats, integers, dates, and the like.

public Key() { super() ; }
public Key(String s) { super() ; name = s ; }
  /*public Key pick ()
  {
	return this ;
  }
  */
public Accessor accessor() 
  { 
	return axessor ;
  }  
public boolean equals (Object obj)
  {
	try 
	  {
	Key k = (Key) obj ;
	return k.name != null && k.name.equals(name) ;
	  }
   catch (Exception e) { return false ; }
  }  
public Class[] getDisplays ()
  {
	return null ;
  }  
public Object [][] getTable (String displayName, String tableName, 
			     String[] params, String ccc)
  {
	if (axessor != null)
	  {
	axessor.getTable(tableName, params, ccc) ;
	  }
	return null ;
  }  
public String name() { return name; }
public void setAccessor (Accessor a)
  { 
	axessor = a ;
  }  
public int status() { return INERT;}
}