/*
 * AceClientS.java
 *
 * Created on July 18, 2000, 11:53 AM
 */
 
package jadeSocket;

import java.io.*;

/** 
 *
 * @author  wgm
 * @version 
 */
public class AceClientS extends Object {

  private JSControl control = null;
  private String host = null;
  private String user = "guest"; 
  private String pwd = "guest";
  private int port;
  
  private boolean debug = false;
  
  /** Creates new AceClientS */
  public AceClientS(String host, int port) {
    this.host = host;
    this.port = port;
    control = new JSControl(host, port);
    control.initializeRequest(user, pwd);
    startCommunication();
  }
  
  public AceClientS(String host, int port, String user, String pwd) {
    this.host = host;
    this.port = port;
    this.user = user;
    this.pwd = pwd;
    control = new JSControl(host, port);
    control.initializeRequest(user, pwd);
    startCommunication();
  }
  
  /** Use this method to start contacting with the server */
  private void startCommunication() {
    try {
        while (true) { //If we can be verified by the server, we can start to talk.
          System.out.print("AceDB_Socket> ");
          LineNumberReader query = new LineNumberReader(new InputStreamReader(System.in));
          String queryS = query.readLine();
          if (queryS.length() == 4) queryS = queryS + " ";
          if (debug) System.out.println(queryS);
          control.request(queryS);
          System.out.println(control.getMessage());
          if (queryS.trim().equalsIgnoreCase("quit")) System.exit(0);
        }
    }
    catch (IOException e) {
      System.out.println(e);
      System.exit(2);
    }
  }
  
  public static void main(String[] args) {
    if ((args.length != 2) && (args.length != 4)) {
      System.out.println("Usage: java AceClientS host port (user pwd)");
      System.exit(0);
    }
    String host = args[0];
    int port = Integer.parseInt(args[1]);
    String user = null;
    String pwd = null;
    if (args.length == 4) {
      user = args[2];
      pwd = args[3];
    }
    else {
      user = "guest";
      pwd = "guest";
    }
    new AceClientS(host, port, user, pwd);
  }
  
}