/*
 * AceClientSwing.java
 *
 * Created on July 25, 2000, 3:43 PM
 */
 
package jadeSocket;

import javax.swing.*;
import java.awt.event.*;
import jadex.swing.*;
import java.beans.*;

/** 
 *
 * @author  wgm
 * @version 
 */
public class AceClientSwing extends JFrame implements PropertyChangeListener {

  private ConnectPanel connectP = null;
  private QueryPanel queryP = null;
  private JSControl control = null;
  
  /** Creates new AceClientSwing */
  public AceClientSwing() {
    super.setTitle("AceClient");
    super.setSize(400, 400);
    super.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) { System.exit(0); }
    });
    initialize();
  }
  
  private void initialize() {
    connectP = new ConnectPanel();
    queryP = new QueryPanel();
    connectP.addPropertyChangeListener(this);
    super.getContentPane().add(connectP, "Center");
    super.setVisible(true);
  }
  
  public void propertyChange(final java.beans.PropertyChangeEvent p1) {
    String user = null;
    String pwd = null;

    if (p1.getPropertyName().equalsIgnoreCase("buttonClicked")) {
      control = connectP.getControl();

      user = connectP.getUser();

      pwd = connectP.getPwd();

      if ((control != null) && (user != null) && (pwd != null)) {
        control.initializeRequest(user, pwd);
        connectP.setVisible(false);
        queryP.setJSControl(control);
        this.getContentPane().removeAll();
        this.getContentPane().add(queryP, "Center");
        this.validate();
        //this.repaint();
      }
    }
  }
  
  
  public static void main (String[] args) {
    new AceClientSwing();
  }
}