/**This class is used as a control in this package, and get some duty 
 * responsibilities from JSAceClient class
 */

package jadeSocket;

import java.io.*;
import java.net.*;

public class JSControl {

  private JSAceClient client = null; // The client side to the Socket of AceDB.
  private String message = null;

  // For encore talking between client and server
  private boolean encore = false;
  private StringBuffer msgBuffer = null;
  private String user = null;
  private String pwd = null;
  private String host = null;
  private int port;
  
  private boolean debug = false; // Control debug mode.
 
  /** Constructor with host and port
   */
  public JSControl (String host, int port) {
    super();
    this.host = host;
    this.port = port;
    client = new JSAceClient(host, port);
    //initializeRequest();
  }


  public void initializeRequest(String user, String pwd) {
    this.user = user;
    this.pwd = pwd;
    try {
      client.talk(JSAceClient.HELLO);
      client.verify(user, pwd);
    }
    catch (IOException e) {
      System.out.println("Cannot establish connection: " + e);
      System.exit(0);
    }
  }

  protected void reInitializeRequest() {
      client = null;
      client = new JSAceClient(host, port);
      initializeRequest(user, pwd);
  }
  
  private void setMessage(String msg) {
    this.message = msg;
  }

  public String getMessage() {
    return this.message;
  }

  /** Talk to the server through JSclient. This is a rather heavy method.
   */
  public synchronized void request(String query) {
    
    if (!encore) msgBuffer = new StringBuffer();
    try { client.talk(query); }
    catch (Exception e) {
        System.err.println("JSControl.request(): " + e);
      reInitializeRequest();
      encore = false;
      request(query);
      return;
    }
    if (client.getMsgType().equalsIgnoreCase(JSAceClient.ACESERV_MSGENCORE)) {
      encore = true;
      msgBuffer.append(client.getMessage());
      request(JSAceClient.ENCORE);
    }
    encore = false;
    msgBuffer.append(client.getMessage());
    setMessage(msgBuffer.toString());
    if (debug) System.out.println("Message from server in JSControl: " + msgBuffer.toString());
  }
}