package jadeSocket;

/** A test class for Java MD5 */

import java.security.*;

public class MD5Test {
  
  public static void main (String args[]) {
    
    if (args.length == 0) {
      System.out.println("Usage: java MD5 input1 *");
      System.exit(0);
    }
   
    MD5Test test = new MD5Test();
    String result = test.getMD5(args);
    System.out.println("After digested: " + result + " ---- length: " + result.length());
  }
  
  private MessageDigest md = null; //MD engine class holder
  
  /** Constructor for initializing the MD5 engine: default from SUN */
  public MD5Test() {
    try {
      md = MessageDigest.getInstance("MD5");
      md.reset();
    }
    catch (Exception e) { System.out.println("Constructor in MDTest: " + e); }
  }
  
  /** The method to get MD5 HexString, which is called by the client (OO concept) */
  public String getMD5 (String[] input) {
    
    String rtn = null;
    
    for (int i = 0; i < input.length; i++) 
      md.update(input[i].getBytes());
    
    byte result[];
    
    try { 
      result = md.digest();
      rtn = computeDigest(result);
    }
    catch (Exception e) { System.out.println("MDTest.getMD5: " + e); }
    
    return rtn;
  }  
  
  /** The method for distributing some responsibility from the getMD5() method */
  protected String computeDigest(byte[] input) {
    StringBuffer result = new StringBuffer();
    for (int i = 0; i < input.length; i++) {
      if ((0xFF & input[i]) < 0x10)
        result.append("0" + Integer.toHexString(0xFF & input[i]));
      else  
        result.append(Integer.toHexString(0xFF & input[i]));
    }
    return result.toString();
  }
}
