package jadex.swing;

/**
 * This type was created in VisualAge.
 */
import javax.swing.tree.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;

/** This is the entry point for Java AceDB browser.
 */
public class AceDBFrame extends JFrame implements java.awt.event.MouseListener, java.awt.event.WindowListener, java.beans.PropertyChangeListener {

    private JPanel ivjJFrameContentPane = null;
    private JSplitPane ivjJSplitPane1 = null;
    private JTree ivjJTree2 = null;
    private java.util.Vector fieldNames = new java.util.Vector();
    private JScrollPane ivjJScrollPane1 = null;
    private AceModel ivjAceModel = null;
    private JTabbedPane ivjJTabbedPane1 = null;
    private JPanel ivjPage = null;
    private ClassViewController controller;
    private WelcomePane first = new WelcomePane();
    private TreePath lastPath = null;
    private TreePath currentPath = null;
    private String title = null;
    private final String DATABASE_NAME = "AceDB";
    private String host = null;
    private int port;

    private class CancellAction implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            if (e.getActionCommand() == "Cancel") {
                currentPath = lastPath;
                getJTree2().setSelectionPath(lastPath);
                getJTree2().scrollPathToVisible(lastPath);
            }
        }
    };
    /**
     * Constructor
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public AceDBFrame() {
        super();
        getHostAndPort();
        //initialize();
    }

    /** Another constructor with host and port arguments
     * @param host The AceDB host name
     * @param port  The AceDB port number
     */
    public AceDBFrame(String host, int port) {
        super();
        this.host = host;
        this.port = port;
        initialize();
    }
    
    /** A method to get host and port information from the ConnectPanel.
    */
    private void getHostAndPort() {
        final JFrame connWindow = new JFrame("Specify a AceDB ... ");
        connWindow.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
        final jadeSocket.ConnectPanel connP = new jadeSocket.ConnectPanel();
        connP.hideUserAndPwd();
        connWindow.setSize(400, 300);
        connWindow.getContentPane().add(connP, "Center");
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        connWindow.setLocation((screenSize.width - 400)/2, (screenSize.height - 300)/2);
        connWindow.setVisible(true);
        PropertyChangeListener listener = new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                if (e.getPropertyName().equalsIgnoreCase("buttonClicked")) {
                    host = connP.getHost();
                    port = connP.getPort();
                    connWindow.setVisible(false);
                    connWindow.dispose();
                    initialize();
                }
            }
        };
        connP.addPropertyChangeListener(listener);
    }
    /**
     */
    public void aceDBFrame_WindowClosed(java.awt.event.WindowEvent windowEvent) {
        System.exit(0);
    }
    private void addTab(JPanel panel) {
        getJTabbedPane1().removeAll();
        getJTabbedPane1().addTab(panel.getName(), panel);
    }
    /**
     * connEtoC1:  (AceDBFrame.window.windowClosed(java.awt.event.WindowEvent) --> AceDBFrame.aceDBFrame_WindowClosed(Ljava.awt.event.WindowEvent;)V)
     * @param arg1 java.awt.event.WindowEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private void connEtoC1(java.awt.event.WindowEvent arg1) {
        try {
            // user code begin {1}
            // user code end
            this.aceDBFrame_WindowClosed(arg1);
            // user code begin {2}
            // user code end
        } catch (java.lang.Throwable ivjExc) {
            // user code begin {3}
            // user code end
            handleException(ivjExc);
        }
    }
    /**
     * connEtoC2:  (JTree2.mouse.mouseClicked(java.awt.event.MouseEvent) --> AceDBFrame.jTree2_TreeSelectionEvents1()V)
     * @param arg1 java.awt.event.MouseEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private void connEtoC2(java.awt.event.MouseEvent arg1) {
        try {
            // user code begin {1}
            // user code end
            this.jTree2_MouseClickEvents1(arg1);
            // user code begin {2}
            // user code end
        } catch (java.lang.Throwable ivjExc) {
            // user code begin {3}
            // user code end
            handleException(ivjExc);
        }
    }
    /**
     * Return the AceModel property value.
     * @return jadex.swing.AceModel
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public AceModel getAceModel() {
        if (ivjAceModel == null) {
            try {
                ivjAceModel = new jadex.swing.AceModel();
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        };
        return ivjAceModel;
    }
    /**
     * Return the JFrameContentPane property value.
     * @return javax.swing.JPanel
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private JPanel getJFrameContentPane() {
        if (ivjJFrameContentPane == null) {
            try {
                ivjJFrameContentPane = new javax.swing.JPanel();
                ivjJFrameContentPane.setName("JFrameContentPane");
                ivjJFrameContentPane.setLayout(new java.awt.BorderLayout());
                getJFrameContentPane().add(getJSplitPane1(), "West");
                getJFrameContentPane().add(getJTabbedPane1(), "Center");
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        };
        return ivjJFrameContentPane;
    }
    /**
     * This method was created in VisualAge.
     */
    /** Set up the menu used to add more function. */
    private void setMenu() {
        JMenuBar bar = new JMenuBar();
        JMenu menu1 = new JMenu("File");
        JMenu menu2 = new JMenu("Search");
        JMenu menu3 = new JMenu("Tools");
        JMenuItem quit = new JMenuItem("Quit");
        quit.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }
        });

        JMenuItem classSearch = new JMenuItem("Object Search");
        classSearch.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                final SearchPanel sp = new SearchPanel();
                sp.setDbFrame(AceDBFrame.this);
            }
        });

        JMenuItem viewSetting = new JMenuItem("ClassView Setting");
        viewSetting.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ViewSettingPanel vsp = new ViewSettingPanel();
                vsp.setDbFrame(AceDBFrame.this);
            }
        });
        menu1.add(quit);
        menu2.add(classSearch);
        menu3.add(viewSetting);
        bar.add(menu1);
        bar.add(menu2);
        bar.add(menu3);
        this.setJMenuBar(bar);
    }
    /**
     * Return the JScrollPane1 property value.
     * @return javax.swing.JScrollPane
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private JScrollPane getJScrollPane1() {
        if (ivjJScrollPane1 == null) {
            try {
                ivjJScrollPane1 = new javax.swing.JScrollPane();
                ivjJScrollPane1.setName("JScrollPane1");
                getJScrollPane1().setViewportView(getJTree2());
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        };
        return ivjJScrollPane1;
    }
    /**
     * Return the JSplitPane1 property value.
     * @return javax.swing.JSplitPane
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private JSplitPane getJSplitPane1() {
        if (ivjJSplitPane1 == null) {
            try {
                ivjJSplitPane1 = new javax.swing.JSplitPane(javax.swing.JSplitPane.HORIZONTAL_SPLIT);
                ivjJSplitPane1.setName("JSplitPane1");
                ivjJSplitPane1.setAutoscrolls(false);
                ivjJSplitPane1.setLastDividerLocation(200);
                ivjJSplitPane1.setDividerLocation(200);
                ivjJSplitPane1.setOneTouchExpandable(false);
                ivjJSplitPane1.setContinuousLayout(false);
                getJSplitPane1().add(getJScrollPane1(), "left");
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        }
        return ivjJSplitPane1;
    }
    /**
     * Return the JTabbedPane1 property value.
     * @return javax.swing.JTabbedPane
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private JTabbedPane getJTabbedPane1() {
        if (ivjJTabbedPane1 == null) {
            try {
                ivjJTabbedPane1 = new javax.swing.JTabbedPane();
                ivjJTabbedPane1.setName("JTabbedPane1");
                ivjJTabbedPane1.setDoubleBuffered(true);
                ivjJTabbedPane1.insertTab("Welcome", null, getPage(), null, 0);
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        };
        return ivjJTabbedPane1;
    }
    /**
     * Return the JTree2 property value.
     * @return javax.swing.JTree
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private JTree getJTree2() {
        if (ivjJTree2 == null) {
            try {
                ivjJTree2 = new javax.swing.JTree();
                ivjJTree2.setName("JTree2");
                ivjJTree2.setAutoscrolls(true);
                ivjJTree2.setBounds(0, 27, 199, 311);
                // user code begin {1}
                javax.swing.tree.DefaultMutableTreeNode root = new javax.swing.tree.DefaultMutableTreeNode (DATABASE_NAME);
                javax.swing.tree.DefaultMutableTreeNode node = new javax.swing.tree.DefaultMutableTreeNode();
                java.util.Vector names = getNames();
                for (int i = 0; i < names.size(); i++) {
                    node = new javax.swing.tree.DefaultMutableTreeNode(names.elementAt(i));
                    root.add(node);
                }
                ivjJTree2 = new javax.swing.JTree (root);
                ivjJTree2.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        };
        return ivjJTree2;
    }
    /**
     * Gets the names property (java.util.Vector) value.
     * @return The names property value.
     * @see #setNames
     */
    public java.util.Vector getNames() {
        return fieldNames;
    }
    /**
     * Return the Page property value.
     * @return javax.swing.JPanel
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private JPanel getPage() {
        if (ivjPage == null) {
            try {
                ivjPage = new javax.swing.JPanel();
                ivjPage.setName("Page");
                ivjPage.setLayout(null);
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        };
        return ivjPage;
    }
    /**
     * Called whenever the part throws an exception.
     * @param exception java.lang.Throwable
     */
    private void handleException(Throwable exception) {

        /* Uncomment the following lines to print uncaught exceptions to stdout */
        // System.out.println("--------- UNCAUGHT EXCEPTION ---------");
        // exception.printStackTrace(System.out);
    }
    /**
     * Initializes connections
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private void initConnections() {
        // user code begin {1}
        // user code end
        this.addWindowListener(this);
        getJTree2().addMouseListener(this);
    }
    /**
     * Initialize the class.
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private void initialize() {
        // user code begin {1}
        if ((host != null) && (port != 0)) ivjAceModel = new AceModel(host, port);
        else ivjAceModel = new AceModel();
        setNames(ivjAceModel.getCategory());

        // user code end
        setName("AceDBFrame");
        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setSize(700, 400);
        setTitle("AceDBViewer");
        setContentPane(getJFrameContentPane());
        initConnections();
        // user code begin {2}
        this.setMenu();
        first.setMessage("Click an entry on the left pane to show information!");
        addTab(first);
        controller = new ClassViewController();
        controller.setAceModel(getAceModel());
        controller.addPropertyChangeListener(this);
        controller.addCancelActionListener(new CancellAction());
        setVisible(true);
        // user code end
    }
    /**
     * Comment
     */
    public void jTree2_MouseClickEvents1(java.awt.event.MouseEvent e) {
        TreePath current = getJTree2().getPathForLocation(e.getX(), e.getY());
        title = current.getLastPathComponent().toString();

        if (title == DATABASE_NAME) {
            getJTree2().setSelectionPath(currentPath);
            return; //If AceDB is clicked, do nothing.
        }

        lastPath = currentPath;
        currentPath = current;

        WelcomePane msg = new WelcomePane();
        msg.setMessage("Working, Please wait...");
        addTab(msg);
        getJTree2().setEnabled(false);
        getJTree2().removeMouseListener(this);

        controller.setClassName(title);
    }
    /**
     * main entrypoint - starts the part when it is run as an application
     * @param args java.lang.String[]
     */
    public static void main(java.lang.String[] args) {

        AceDBFrame aAceDBFrame;
        if (args.length < 2) {         
            aAceDBFrame = new AceDBFrame();
        }
        else {
            String host = args[0];
            String portS = args[1];
            int port = Integer.parseInt(portS);
            aAceDBFrame = new AceDBFrame(host, port);
        }
        //aAceDBFrame.setVisible(true);
    }
    
    /** A helper to process propertyChange Listener */
    private static AceDBFrame constructAceDB(String host, int port) {
        return new AceDBFrame(host, port);
    }
    
    
    /**
     * Method to handle events for the MouseListener interface.
     * @param e java.awt.event.MouseEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public void mouseClicked(java.awt.event.MouseEvent e) {
        // user code begin {1}
        // user code end
        // user code begin {2}
        // user code end
    }
    /**
     * Method to handle events for the MouseListener interface.
     * @param e java.awt.event.MouseEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public void mouseEntered(java.awt.event.MouseEvent e) {
        // user code begin {1}
        // user code end
        // user code begin {2}
        // user code end
    }
    /**
     * Method to handle events for the MouseListener interface.
     * @param e java.awt.event.MouseEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public void mouseExited(java.awt.event.MouseEvent e) {
        // user code begin {1}
        // user code end
        // user code begin {2}
        // user code end
    }
    /**
     * Method to handle events for the MouseListener interface.
     * @param e java.awt.event.MouseEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public void mousePressed(java.awt.event.MouseEvent e) {
        // user code begin {1}
        // user code end
        if ((e.getSource() == getJTree2()) ) {
            connEtoC2(e);
        }
        // user code begin {2}
        // user code end
    }
    /**
     * Method to handle events for the MouseListener interface.
     * @param e java.awt.event.MouseEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public void mouseReleased(java.awt.event.MouseEvent e) {
        // user code begin {1}
        // user code end
        // user code begin {2}
        // user code end
    }
    public void propertyChange(java.beans.PropertyChangeEvent arg1) {
        JPanel newValue = (JPanel) arg1.getNewValue();

        if (newValue == null) {
            getJTree2().setEnabled(true);
            getJTree2().addMouseListener(this);
            title = null;
            addTab(first);
            return;
        }

        if (newValue instanceof ProgressPanel) {
            getJTree2().setEnabled(false);
            getJTree2().removeMouseListener(this);
            addTab(newValue);
            return;
        }

        else {
            getJTree2().setEnabled(true);
            getJTree2().removeMouseListener(this); //Just in case that there should be two this listener.
            getJTree2().addMouseListener(this);
            addTab(newValue);
            return;
        }
    }
    /**
     * Sets the names property (java.util.Vector) value.
     * @param names The new value for the property.
     * @see #getNames
     */
    public void setNames(java.util.Vector names) {
        fieldNames = names;
    }
    /**
     * Method to handle events for the WindowListener interface.
     * @param e java.awt.event.WindowEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public void windowActivated(java.awt.event.WindowEvent e) {
        // user code begin {1}
        // user code end
        // user code begin {2}
        // user code end
    }
    /**
     * Method to handle events for the WindowListener interface.
     * @param e java.awt.event.WindowEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public void windowClosed(java.awt.event.WindowEvent e) {
        // user code begin {1}
        // user code end
        if ((e.getSource() == this) ) {
            connEtoC1(e);
        }
        // user code begin {2}
        // user code end
    }
    /**
     * Method to handle events for the WindowListener interface.
     * @param e java.awt.event.WindowEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public void windowClosing(java.awt.event.WindowEvent e) {
        // user code begin {1}
        // user code end
        // user code begin {2}
        // user code end
    }
    /**
     * Method to handle events for the WindowListener interface.
     * @param e java.awt.event.WindowEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public void windowDeactivated(java.awt.event.WindowEvent e) {
        // user code begin {1}
        // user code end
        // user code begin {2}
        // user code end
    }
    /**
     * Method to handle events for the WindowListener interface.
     * @param e java.awt.event.WindowEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public void windowDeiconified(java.awt.event.WindowEvent e) {
        // user code begin {1}
        // user code end
        // user code begin {2}
        // user code end
    }
    /**
     * Method to handle events for the WindowListener interface.
     * @param e java.awt.event.WindowEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public void windowIconified(java.awt.event.WindowEvent e) {
        // user code begin {1}
        // user code end
        // user code begin {2}
        // user code end
    }
    /**
     * Method to handle events for the WindowListener interface.
     * @param e java.awt.event.WindowEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public void windowOpened(java.awt.event.WindowEvent e) {
        // user code begin {1}
        // user code end
        // user code begin {2}
        // user code end
    }
}