package jadex.swing;

/**
 * This type was created in VisualAge.
 */
import jade.db.*;
import java.io.*;
import java.net.*;
import java.util.*;

/** This class handles all data related to class displaying. The actual data will
 * be fetched from AceDB in this class.
 */

public class AceModel {
    private java.util.Vector fieldCategory = new java.util.Vector();
    private AceAccessor fieldAccessor;
    private boolean debug = false;
    private String host = null;
    private int port;
    /**
     * AceModel constructor comment.
     */
    public AceModel() {
        super();
        init();
    }
    /** Another constructor with host and port as the arguaments */

    public AceModel(String host, int port) {
        super();
        this.host = host;
        this.port = port;
        //init();
        init(false);
    }
    private void init(boolean isDirect) {
        if (!isDirect) init();
        else {
            JSAceAccessor worm = new JSAceAccessor(host, port);
            setAccessor(worm);
            Vector v = worm.classes();
            setCategory(v);
        }
    }

    private Vector parseMessage(String str) {
        Vector v = new Vector();
        System.out.println("ParseMessage in AceModel: " + str);
        try {
            LineNumberReader lnr = new LineNumberReader(new CharArrayReader(str.toCharArray()));
            lnr.readLine();
            String s = null;
            while ((s = lnr.readLine()) != null) {
                if (s.length() == 0) continue;
                System.out.println("ParseMessage in AceModel: " + s);
                if (s.indexOf("Active Object") > -1) break;
                int pos = s.lastIndexOf(" ");
                String name = s.substring(0, pos).trim();
                System.out.println(name);

                v.addElement(name);
            }
        }
    catch(IOException e) { System.out.println(e); }

        return v;
    }

    /**
     * An Overloaded constructur with Accessor as the sole argument.
     */
    public AceModel(Accessor accessor) {
        super();
        try {
            setAccessor((AceAccessor) accessor);
        }
    catch (ClassCastException e) { System.err.println(e); }
    }
    /**
     * Gets the accessor property (jade.db.AceAccessor) value.
     * @return The accessor property value.
     * @see #setAccessor
     */
    public AceAccessor getAccessor() {
        return fieldAccessor;
    }
    /**
     * Gets the category property (java.util.Vector) value.
     * @return The category property value.
     * @see #setCategory
     */
    public java.util.Vector getCategory() {
        return fieldCategory;
    }
    /**
     * AceModel constructor comment.
     */
    private void init() {
        AceAccessor worm = null;

        if (host == null) worm = new JSAceAccessor ("alpha.crbm.cnrs-mop.fr", 20100);
        else worm = new JSAceAccessor (host, port);
        setAccessor(worm);

    String[] para = {"Visible"};
        Object[][] result = worm.getTable("Classes", para, "k");

        java.util.Vector v = new java.util.Vector();
        AceObject ab = null;

        for (int i = 0; i < result.length; i++) {
            for (int j = 0; j < result[i].length; j++) {
                ab = (AceObject) result[i][j];
                v.addElement(ab.name());
                if (debug) System.out.println(result[i][j]);
            }
        }

        setCategory(v);

    }
    /**
     * Starts the application.
     * @param args an array of command-line arguments
     */
    public static void main(java.lang.String[] args) {
        // Insert code to start the application here.
        new AceModel(args[0], Integer.parseInt(args[1]));
    }
    /**
     * Sets the accessor property (jade.db.AceAccessor) value.
     * @param accessor The new value for the property.
     * @see #getAccessor
     */
    public void setAccessor(AceAccessor accessor) {
        fieldAccessor = accessor;
    }
    /**
     * Sets the category property (java.util.Vector) value.
     * @param category The new value for the property.
     * @see #getCategory
     */
    public void setCategory(java.util.Vector category) {

        fieldCategory = category;
    }
}