package jadex.swing;

/**
 * This type was created in VisualAge.
 */
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;

/** This class is used to control the selection activity in CategoryTree.
 */

public class CategoryTreeSelectionListener implements TreeSelectionListener {

    private JTabbedPane tabbedPane;

    /**
     * Default constructor.
     */
    public CategoryTreeSelectionListener() {
        super();
    }
    /**
     * An overloaded constructor with a JTabbedPane as the only argument.
     * @param pane the JTabbedPane to display the selected object
     */
    public CategoryTreeSelectionListener(JTabbedPane pane) {
        super();
        setTabbedPane(pane);
    }

    /** Export the JTabbedPane
     * @return the JTabbedPane to display the objects of the selected class.
     */

    public JTabbedPane getTabbedPane () {
        if (tabbedPane != null) return tabbedPane;
        else return null;
    }

    /** Set the JTabbedPane
     * @param panel the JTabbedPane to be dispplayed.
     */
    public void setTabbedPane (JTabbedPane pane) {
        if (tabbedPane == null) tabbedPane = pane;
    }

    /** The actual selectionListener method to process the selection evenet in CategoryTree.
     * @param e a TreeSelectionEvent to be processed.
     */
    public void valueChanged (TreeSelectionEvent e) {

        String classe;
        int count;

        classe = e.getPath().getLastPathComponent().toString();
        if (tabbedPane != null) {
            tabbedPane.setTitleAt(0,classe);

            //Have to call these JTabbedPane method to get appropriate width for title. Why?
            tabbedPane.requestFocus();
            tabbedPane.repaint();
            tabbedPane.revalidate();
        }
    }
}