package jadex.swing;

/**
 * This type was created in VisualAge.
 */
import javax.swing.JLabel;
 

/** This is the model class to store all class counting information for ClassDisplayer. 
*/

public class ClassDisplayerModel {
	private String className;
	private int count;
	private JLabel[] labels;
	private JLabel labelAll;
/**
 * Default constructor.
 */
public ClassDisplayerModel() {
	super();
}
/**
 * A overloaded construcotr.
 * @param classe java.lang.String
 * @param Count int
 * @param labels JLabel[]
 */
public ClassDisplayerModel(String classe, int count, JLabel[] labels, JLabel labelAll) {
	super();
	setClassName(classe);
	setCount(count); //Total entries of the class
	setLabels(labels);
	setLabelAll(labelAll);
}
/**
 * Get the displayed class name.
 * @return the name of the displayed class.
 */
public String getClassName() {
	return className;
}
/**
 * Get the total count of the displayed class.
 * @return the total count of the entries of the displayed class.
 */
public int getCount() {
	return count;
}
public JLabel getLabelAll() { return this.labelAll; }
/**
 * Get all 26 labels, each of which is for one letter.
 * @return the 26 JLabels.
 */
public JLabel[] getLabels() {
	return labels;
}
/**
 * Get a indexed JLabel from the JLabel array.
 * @return the JLabel with the specified index.
 */
public JLabel getLabels(int index) {
	if ((index > 0) && (index < labels.length)) 
		return labels[index];
	else return null;
}
/**
 * Set the class name.
 * @param newValue the name of the new class to be displayed.
 */
public void setClassName(String newValue) {
	this.className = newValue;
}
/**
 * Set the total count.
 * @param newValue the total count of the objects in the class to be displayed.
 */
public void setCount(int newValue) {
	this.count = newValue;
}

/** Set the JLabel, LabelAll.
*/
public void setLabelAll(JLabel label) { this.labelAll = label; }
/**
 * Set all 26 JLabels.
 * @param newValue A JLabel array to be set.
 */
public void setLabels(JLabel[] newValue) {
	this.labels = newValue;
}
/**
 * Set a specific JLabel at index index.
 * @param index the position of the JLabel in label array.
 * @param newValue a new JLabel.
 */
public void setLabels(int index, JLabel newValue) {
	labels[index] = newValue;
}
}