package jadex.swing;

/**
 * This is an adapter class to mediate the activities between ClassListdisplayer
 * and ClassListModel.
 */

public class ClassListMediator implements java.awt.event.ActionListener, java.awt.event.ItemListener {

    private ClassListDisplayer displayer = null;
    private ClassListModel model = null;
    private int selectedPage;

    private String letter;
    private int selectedLetterIndex;
    /**
     * Default constructor.
     */
public ClassListMediator() {}
    /**
     * An overloaded constructor.
     * @param displayer the ClassListDisplayer to be mediated by this class.
     * @param model the ClassListModel to ne mediated by this class.
     */
    public ClassListMediator(ClassListDisplayer displayer, ClassListModel model) {
        super();
        this.displayer = displayer;
        this.model = model;
    }
    /**
     * The actionListener method.
     */
    public void actionPerformed(java.awt.event.ActionEvent e) {
        String command = e.getActionCommand();
        if (command == "previous") {
            javax.swing.JComboBox cb = displayer.getPageBox();
            cb.setSelectedIndex(cb.getSelectedIndex() - 1);
            cb.repaint();
        }
        else if(command == "next") {
            javax.swing.JComboBox cb = displayer.getPageBox();
            cb.setSelectedIndex(cb.getSelectedIndex() + 1);
            cb.repaint();
        }
        else if (command == "All...") {
            javax.swing.JComboBox cb = displayer.getLetterBox();
            cb.setSelectedIndex(0);
            cb.repaint();
        }
    }
    /**
     * Get the selected letter.
     */
    protected String getLetter() {
        return letter;
    }

    /**
     * Get the selected page.
     */
    protected int getSelectedPage() {
        return selectedPage;
    }

    /**
     * ItemSelectionListener method.
     */
    public void itemStateChanged(java.awt.event.ItemEvent e) {
        if (e.getStateChange() == java.awt.event.ItemEvent.SELECTED) {
            if (e.getSource() == displayer.getPageBox()) {
                String selected = (String) e.getItem();
                selectedPage = Integer.parseInt(selected);
                String letter = getLetter();
                int start = (selectedPage - 1) * ClassListDisplayer.TOTAL_LIST_NUMBER;
                model.fetchObjects(letter, start, ClassListDisplayer.TOTAL_LIST_NUMBER);
            }

            else if (e.getSource() == displayer.getLetterBox()) {
                parseSelectedItem();
            }
        }
    }

    /* This method used to parse the selected item in the letterbox. **/

    private void parseSelectedItem() {
        selectedLetterIndex = displayer.getLetterBox().getSelectedIndex();
        String selectedLetter = (String) displayer.getLetterBox().getSelectedItem();
        int index = selectedLetter.indexOf(":");
        String letter = selectedLetter.substring(0, index);
        setLetter(letter);

        java.util.StringTokenizer tokenizer = new java.util.StringTokenizer(selectedLetter.substring(index+1));
        String first = tokenizer.nextToken();
        int total = Integer.parseInt(first);
        setPageBox(total);
    }

    public void setDisplayer(ClassListDisplayer displayer) {
        this.displayer = displayer;
    }

    private void setLetter(String letter) {
        this.letter = letter;
    }

    public void setModel(ClassListModel model) {
        this.model = model;
    }

    private void setPageBox(int total) {
        displayer.setPageBox(total);
    }
}