package jadex.swing;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import jade.db.*;
import java.util.*;

/**
 * This class is used to control the activities in ClassDisplayer and ClassListDisplayer.
 */

public class ClassViewController implements MouseListener {

	protected class CancellAction implements ActionListener {
		public void actionPerformed (ActionEvent e) {
                        tStop = true;
			setCurrentPanel(lastPanel);
		}
	}
	
	private JPanel fieldCurrentPanel = null;
	private JPanel lastPanel = null;
	protected transient java.beans.PropertyChangeSupport propertyChange;
	private String fieldClassName = null;
	private AceModel aceModel;
	private AceAccessor accessor;
	private ClassDisplayer ivjClassDisplayer1 = null;
	private ClassListDisplayer ivjClassListDisplayer1 = null;
	private int total; //Total entries of the class.
	private int[] eachCount = new int[26]; //Counts of 26 index.?
	private Thread t = new Thread();
        private boolean tStop;
	private Vector  cancellListeners = new Vector();
	private Vector objectList;

	private final int MAXNUMBER = 1000;
	private int currentPosition = 0;  //the current postion in AceDB
/**
 * Default constructor.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public ClassViewController() {
	super();
}
/**
 * TA overloaded constructor.
 * @param classe the name of the displaying class.
 * @param model the AceModel for this classdisplay.
 */
public ClassViewController(String classe, AceModel model) {
	super();
	setClassName(classe);
	setAceModel(model);
	initialize();
}
/**
 * Add a actionListener for Cancel button.
 * @param l java.awt.event.ActionListener
 */
public void addCancelActionListener(ActionListener l) {
	cancellListeners.addElement(l);
}
/**
 * The addPropertyChangeListener method was generated to support the propertyChange field.
 */
public synchronized void addPropertyChangeListener(java.beans.PropertyChangeListener listener) {
	getPropertyChange().addPropertyChangeListener(listener);
}
/**
 * The firePropertyChange method was generated to support the propertyChange field.
 */
public void firePropertyChange(String propertyName, Object oldValue, Object newValue) {
	getPropertyChange().firePropertyChange(propertyName, oldValue, newValue);
}
/**
 * @return jadex.swing.AceModel
 */
public AceModel getAceModel() {
	return aceModel;
}
/**
 * Return the ClassDisplayer1 property value.
 * @return jadex.swing.ClassDisplayer
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private ClassDisplayer getClassDisplayer1() {
	// user code begin {1}
	// user code end
	return ivjClassDisplayer1;
}
/**
 * Return the ClassListDisplayer1 property value.
 * @return jadex.swing.ClassListDisplayer
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private ClassListDisplayer getClassListDisplayer1() {
	// user code begin {1}
	// user code end
	return ivjClassListDisplayer1;
}
/**
 * Gets the className property (java.lang.String) value.
 * @return The className property value.
 * @see #setClassName
 */
public String getClassName() {
	return fieldClassName;
}
/**
 * Gets the currentPanel property (javax.swing.JPanel) value.
 * @return The currentPanel property value.
 * @see #setCurrentPanel
 */
public JPanel getCurrentPanel() {
	return fieldCurrentPanel;
}
/**
 * Get the currentPosition in AceDB.
 * @return the position in AceDB.
 */
private int getCurrentPosition() {
	return currentPosition;
}
/**
 * Accessor for the propertyChange field.
 */
protected java.beans.PropertyChangeSupport getPropertyChange() {
	if (propertyChange == null) {
		propertyChange = new java.beans.PropertyChangeSupport(this);
	};
	return propertyChange;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * This method was created in VisualAge.
 */
private void initialize() {
	// user code begin {1}
	if (accessor != null) {
		t = new Thread(new Runnable() {
			public void run() {
				String name = getClassName();
				JLabel[] localLabels = new JLabel[26];
				JLabel localAll = new JLabel();
				localAll.setText("All...");
				localAll.setFont(new Font("Monospaced", Font.BOLD, 12));
				localAll.setBorder(new javax.swing.border.EtchedBorder());
				ProgressPanel progress = new ProgressPanel();
				progress.setName("Downloading");
				progress.setMaximum(localLabels.length);
				progress.addActionListener(new CancellAction());
			
				for (int i = 0; i < cancellListeners.size(); i++)
					progress.addActionListener((ActionListener) cancellListeners.elementAt(i));
				
				setCurrentPanel(progress);
				Thread.yield();
				total = accessor.count(name, "*");
				if (total>0) {
					localAll.setForeground(Color.blue);
					localAll.addMouseListener(new MouseSenser(localAll));
					localAll.addMouseListener(ClassViewController.this);
					localAll.setToolTipText("Total: " + total + " entries");
				}
				int j = 0, anotherCount = 0;
				tStop = false;
                                for (char i = 'A'; i <= 'Z'; i++) {
					if (tStop) return;
                                        eachCount[j] = accessor.count(name, i + "*");
					localLabels[j] = new JLabel(i + "");
					localLabels[j].setFont(new Font("Monospaced", Font.BOLD, 12));
					if (eachCount[j] != 0) {
						localLabels[j].setForeground(Color.blue);
						localLabels[j].setToolTipText(i + "*" + ": " + eachCount[j]+ " entries");
						localLabels[j].addMouseListener(new MouseSenser(localLabels[j]));
						localLabels[j].addMouseListener(ClassViewController.this);
					}
					anotherCount = eachCount[j] + anotherCount;
					progress.setValue(j);
					Thread.yield();
					j++;     
				}
				//if (anotherCount != total) System.out.println("Two counts are not the same!");
				ClassDisplayerModel model = new ClassDisplayerModel(name, total, localLabels, localAll);
				setClassDisplayer1(new ClassDisplayer(model));
				setCurrentPanel(getClassDisplayer1());
			}
		});
		t.start();
  	}
	// user code end
	// user code begin {2}
	// user code end
}
public void mouseClicked(MouseEvent e) {
	JLabel label = null;
	try { label = (JLabel) e.getSource(); }
	catch (ClassCastException ex) { System.out.println(ex); }
	ClassListModel listModel = new ClassListModel(accessor, label, getClassDisplayer1().getModel());
	
	setClassListDisplayer1(new ClassListDisplayer(listModel));
	setCurrentPanel(getClassListDisplayer1());
}
public void mouseEntered(MouseEvent e) { }
public void mouseExited(MouseEvent e) { }
public void mousePressed(MouseEvent e) { }
public void mouseReleased(MouseEvent e) { }
/**
 * The removePropertyChangeListener method was generated to support the propertyChange field.
 */
public synchronized void removePropertyChangeListener(java.beans.PropertyChangeListener listener) {
	getPropertyChange().removePropertyChangeListener(listener);
}
/**
 * Set AceModel for displaying.
 * @param newValue jadex.swing.AceModel.
 */
public void setAceModel(AceModel newValue) {
	this.aceModel = newValue;
	this.accessor = aceModel.getAccessor();
	if(getClassName() != null) initialize();
}
/**
 * Set the ClassDisplayer1 to a new value.
 * @param newValue jadex.swing.ClassDisplayer
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void setClassDisplayer1(ClassDisplayer newValue) {
	if (ivjClassDisplayer1 != newValue) {
		try {
			ivjClassDisplayer1 = newValue;
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
}
/**
 * Set the ClassListDisplayer1 to a new value.
 * @param newValue jadex.swing.ClassListDisplayer
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void setClassListDisplayer1(ClassListDisplayer newValue) {
	if (ivjClassListDisplayer1 != newValue) {
		try {
			ivjClassListDisplayer1 = newValue;
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
}
/**
 * Sets the className property (java.lang.String) value.
 * @param className The new value for the property.
 * @see #getClassName
 */
public void setClassName(String className) {
	fieldClassName = className;
	if (accessor != null) initialize();
}
/**
 * Sets the currentPanel property (javax.swing.JPanel) value.
 * @param currentPanel The new value for the property.
 * @see #getCurrentPanel
 */
public void setCurrentPanel(JPanel currentPanel) {
	lastPanel = fieldCurrentPanel;
	fieldCurrentPanel = currentPanel;
	firePropertyChange("currentPanel", lastPanel, currentPanel);
}
/**
 * This method was created in VisualAge.
 * @param newValue int
 */
private void setCurrentPosition(int newValue) {
	this.currentPosition = newValue;
}
}