/*
 * GeneticMapApplet.java
 *
 * Created on August 29, 2000, 5:27 PM
 */
 
package jadex.swing;

import jade.db.*;
import jadex.swing.classView.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/** 
 * This applet is used to launch GeneticMapView applet.
 *
 * @author  wgm
 * @version 1.0
 */
public class GeneticMapApplet extends javax.swing.JApplet {

  private String aceobject = null; // The value should be got from param. Default is null
  private String host = null; // The host for acedb
  private int port; // Port for acedb
  private String cls = null; // AceObject class name 
  private String obj = null; // AceObject object name  
  
  /** Creates new form GeneticMapApplet */
  public void init() {
    aceobject = getParameter("aceobject");
    host = getParameter("host");
    String p = getParameter("port");
    if (p != null) port = Integer.parseInt(p);
    if (host == null) {
      host = "formaggio.cshl.org";
      port = 2005;
    }
    if (aceobject == null) aceobject = new String("I");
    obj = getParameter("obj_name");
    cls = getParameter("obj_class");
    initComponents ();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
private void initComponents () {//GEN-BEGIN:initComponents
    jButton1 = new javax.swing.JButton ();
    jLabel1 = new javax.swing.JLabel ();
    getContentPane ().setLayout (new java.awt.GridBagLayout ());
    java.awt.GridBagConstraints gridBagConstraints1;

    jButton1.setFont (new java.awt.Font ("Dialog", 0, 12));
    jButton1.setText ("Show Genetic Map");
    jButton1.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
            jButton1ActionPerformed (evt);
        }
    }
    );


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 1;
    getContentPane ().add (jButton1, gridBagConstraints1);

    jLabel1.setText ("Click this button to launch the applet...");


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 0;
    gridBagConstraints1.insets = new java.awt.Insets (0, 0, 15, 0);
    getContentPane ().add (jLabel1, gridBagConstraints1);

}//GEN-END:initComponents

  private void jButton1ActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
// Add your handling code here:
    jLabel1.setText("Applet Loading: GeneticMap " + aceobject);
    jButton1.setEnabled(false);
    try {
      AceAccessor accessor = new JSAceAccessor(host, port);
      AceObject map = accessor.fetch("map", aceobject);
      if (map == null) {
	  jLabel1.setText("Sorry, " + aceobject + " cannot be found in this AceDB.");
	  return;
      }
      MapView view = new MapView(map, this);
      if ((obj != null) && (cls != null)) view.search(cls, obj);
      //MapView view = new MapView(map);
      jLabel1.setText("Loading finished: GeneticMap " + map.name());
    }
    catch (Exception e) { 
      System.err.println(e); 
      jLabel1.setText("Sorry, cannot get " + aceobject + ". " + "Reload please.");
    }
  }//GEN-LAST:event_jButton1ActionPerformed


  public void setMessage(String s) {
    jLabel1.setText(s);
  }
  
// Variables declaration - do not modify//GEN-BEGIN:variables
private javax.swing.JButton jButton1;
private javax.swing.JLabel jLabel1;
// End of variables declaration//GEN-END:variables

  
  public static void main(String[] args) {
    JFrame f = new JFrame("Applet Test");
    GeneticMapApplet applet = new GeneticMapApplet();
    f.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) { System.exit(0); }
    });
    f.getContentPane().add(applet, "Center");
    f.setSize(300, 200);
    f.setVisible(true);
  }
}
