package jadex.swing;

/**
 * This type was created in VisualAge.
 */
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

/** The class is used to display the index all the displayed class.
 */

public class IndexSelector extends JPanel {
    private JLabel[] index;  // 26 JLabels for indexing.
    private GridLayout ivjIndexSelectorGridLayout = null;
    /**
     * Default constructor.
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    public IndexSelector() {
        super();
        initialize();
    }
    /**
     * Add a mouselistener to a specified JLabel at position.
     * @param position the position at which l will be added.
     * @param l java.awt.event.MouseListener.
     */
    public void addMouseListener(int position, MouseListener l) {
        if (index[position] != null)
        index[position].addMouseListener(l);
    }
    /**
     * Add a mouselistener to all JLabels.
     * @param l java.awt.event.MouseListener
     */
    public void addMouseListener(MouseListener l) {
        if (index != null) {
            for (int i = 0; i < index.length; i++)
            index[i].addMouseListener(l);
        }
    }
    /**
     * Initialize the JLabel array index.
     */

    /** Should have more efficient way to paint array Index */

    private void draw() {

        removeAll();
        add(new JLabel());

        for (int i = 0; i < index.length; i++)
        add(index[i]);

        add(new JLabel());
    }

    /** Get all JLabels for index.
     * @return a JLabel array.
     */
    public JLabel[] getIndex() {
        if (index != null) return index;
        else return null;
    }

    /** Get the JLabel at position.
     * @param position the index.
     * @return the JLabel at postion.
     */
    public JLabel getIndex(int position) {
        return index[position];
    }
    /**
     * Return the IndexSelectorGridLayout property value.
     * @return java.awt.GridLayout
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private GridLayout getIndexSelectorGridLayout() {
        java.awt.GridLayout ivjIndexSelectorGridLayout = null;
        try {
            /* Create part */
            ivjIndexSelectorGridLayout = new java.awt.GridLayout();
            ivjIndexSelectorGridLayout.setVgap(2);
            ivjIndexSelectorGridLayout.setHgap(2);
            ivjIndexSelectorGridLayout.setColumns(28);
        } catch (java.lang.Throwable ivjExc) {
            handleException(ivjExc);
        };
        return ivjIndexSelectorGridLayout;
    }
    /**
     * Called whenever the part throws an exception.
     * @param exception java.lang.Throwable
     */
    private void handleException(Throwable exception) {

        /* Uncomment the following lines to print uncaught exceptions to stdout */
        // System.out.println("--------- UNCAUGHT EXCEPTION ---------");
        // exception.printStackTrace(System.out);
    }
    /**
     * Initialize the class.
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private void initialize() {
        // user code begin {1}
        // user code end
        setName("IndexSelector");
        setPreferredSize(new java.awt.Dimension(523, 28));
        setLayout(getIndexSelectorGridLayout());
        //setSize(523, 28);
        // user code begin {2}
        initLabels();
        // user code end
    }
    /**
     * Initialize the JLabel array index.
     */

    private void initLabels() {
        int j = 0;

        if (index == null) {
            index = new JLabel[26];
            for (char i = 'A'; i <= 'Z'; i++) {
                index[j] = new JLabel(i + "");
                index[j].setFont(new Font("Monospaced", Font.BOLD, 12));
                index[j].invalidate();
                j++;
            }
        }

        draw();

    }
    /**
     * This method was created in VisualAge.
     * @param args java.lang.String[]
     */
    public static void main(String args[]) {
        try {
            JFrame frame;
            frame = new JFrame();
            frame.setTitle("Index Selector");
            IndexSelector selector = new IndexSelector();
            frame.getContentPane().add(selector, "Center");
            frame.setSize(530, 100);
            frame.setVisible(true);
            frame.addWindowListener(new WindowAdapter() {
                public void windowClosing (WindowEvent e) {
                    System.exit(0);
                }
            });
        }
    catch (Throwable e) {}
    }
    /**
     * @param l java.awt.event.MouseListener
     */
    public void removeMouseListener(int position, MouseListener l) {
        if (index[position] != null)
        index[position].removeMouseListener(l);
    }
    /**
     * @param l java.awt.event.MouseListener
     */
    public void removeMouseListener(MouseListener l) {
        if (index != null) {
            for (int i = 0; i < index.length; i++)
            index[i].removeMouseListener(l);
        }
    }

    /** Set all 26 JLabels
     */
    public void setIndex(JLabel[] labels) {
        if (labels.length == index.length) {
            for (int i = 0; i < index.length; i++)
            index[i] = labels[i];
        }

        draw();
    }

    /** Set the index at specified position.
     */
    public void setIndex(int position, JLabel label) {
        index[position] = label;
        draw();
    }
}