package jadex.swing;

/**
 * This type was created in VisualAge.
 */
/** A utility class used to monitor the mouse activity in JComponent. */
 
import java.awt.event.*;
import java.awt.*;

import javax.swing.*;

/** This class is used to lighten up the label when mouse is in.
*/

public class MouseSenser extends MouseAdapter {
	
	private JComponent comp; 
	private boolean debug = false;

	public static Color OUT_FOREGROUND_COLOR = Color.blue;
	public static Color IN_FOREGROUND_COLOR = Color.red;

/**
 * Default constructor.
 */
public MouseSenser() {
	super();
}
/**
 * An overloaded constructor.
 * @param jc the componenet this mousesenser will control.
 */
public MouseSenser(JComponent jc) {
	super();
	comp = jc;
}
/**
 * MouseSenser constructor comment.
 */
private void draw(Color color) {
	comp.setForeground(color);
	comp.repaint();
	comp.revalidate();
}
/**
 * MouseSenser constructor comment.
 */
public void mouseEntered(MouseEvent e) {
	draw(IN_FOREGROUND_COLOR);
	if (debug) System.out.println("Mouse entered!");
	return;
}
/**
 * MouseSenser constructor comment.
 */
public void mouseExited(MouseEvent e) {
	draw(OUT_FOREGROUND_COLOR);
	if (debug) System.out.println("Mouse Exited!");
	return;
}
}