/*
 * ViewSettingPanel.java
 *
 * Created on July 6, 2000, 2:25 PM
 */
 
package jadex.swing;


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
/** 
 *
 * @author  wgm
 * @version 
 */
public class ViewSettingPanel extends javax.swing.JPanel {  
  
  /** Creates new form ViewSettingPanel */
  public ViewSettingPanel() {
    super();
    initComponents ();
    fillView();
	showPanel();
  }

  private void fillView() {
	String viewname = new String("jadex" + File.separator + "swing" 
								+ File.separator + "classView");
	String pkgName = new String("jadex.swing.classView.");
	File viewDir = new File(viewname);
	if (viewDir.isDirectory()) {
		String[] list = viewDir.list(new FilenameFilter() {
			public boolean accept(File dir, String name) {
				if (name.indexOf(".class") > -1) return true;
				else return false;
			}
		});
		for (int i = 0; i < list.length; i++) {	
			try {
				int pos = list[i].indexOf(".class");
				String cName = list[i].substring(0, pos);
				String pcName = pkgName + cName;
				Class c = Class.forName(pcName);
				String su = c.getSuperclass().getName();
				if (su.equalsIgnoreCase(pkgName + "ClassView")) {
					box2.addItem(pcName);
				}
			}
			catch (ClassNotFoundException e) { System.err.println(e); }
		}
	}
  }
  
  private void showPanel() {
    frame = new JFrame();
    frame.setTitle("Class View Setting");
    frame.setResizable(false);
    this.setPreferredSize(new Dimension(350, 140));
    this.setBorder(BorderFactory.createEtchedBorder());
    frame.getContentPane().add(this, "North");
    details = new JTextArea();
    details.setEditable(false);
    taPanel = new JPanel();
    taPanel.setLayout(new BorderLayout());
    taPanel.setPreferredSize(new Dimension(350, 200));
    taPanel.setBorder(BorderFactory.createEtchedBorder());
    taPanel.add(new JScrollPane(details), "Center");
    taPanel.setVisible(false);
    frame.getContentPane().add(taPanel, BorderLayout.CENTER);
    frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
    frame.pack();
    frame.setVisible(true);
    updateProp();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    jComboBox1 = new javax.swing.JComboBox ();
    //jTextField1 = new javax.swing.JTextField ();
	box2 = new JComboBox();
	jLabel1 = new javax.swing.JLabel ();
    jLabel2 = new javax.swing.JLabel ();
    jButton1 = new javax.swing.JButton ();
    jButton2 = new javax.swing.JButton ();
    setLayout (new java.awt.GridBagLayout ());
    java.awt.GridBagConstraints gridBagConstraints1;

    jComboBox1.setEditable (true);
    jComboBox1.setFont (new java.awt.Font ("Dialog", 0, 12));


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 1;
    gridBagConstraints1.insets = new java.awt.Insets (0, 0, 0, 5);
    gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
    add (jComboBox1, gridBagConstraints1);
	/*
    jTextField1.setPreferredSize (new java.awt.Dimension(48, 22));
    jTextField1.setText ("default");
    jTextField1.setFont (new java.awt.Font ("Dialog", 0, 12));
    jTextField1.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
        jTextField1ActionPerformed (evt);
      }
    }
    );*/
	box2.setEditable(true);
	box2.setFont(new java.awt.Font("Dialog", 0, 12));

    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 3;
    gridBagConstraints1.gridwidth = 0;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
    //add (jTextField1, gridBagConstraints1);
	add(box2, gridBagConstraints1);

    jLabel1.setText ("Select Class");
    jLabel1.setFont (new java.awt.Font ("Dialog", 0, 12));


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 0;
    gridBagConstraints1.ipady = 2;
    gridBagConstraints1.insets = new java.awt.Insets (25, 0, 0, 0);
    gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
    add (jLabel1, gridBagConstraints1);

    jLabel2.setText ("Input Or Select View Class (including package name)");
    jLabel2.setFont (new java.awt.Font ("Dialog", 0, 12));


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 2;
    gridBagConstraints1.ipady = 2;
    gridBagConstraints1.insets = new java.awt.Insets (5, 0, 0, 0);
    add (jLabel2, gridBagConstraints1);

    jButton1.setText ("OK");
    jButton1.setFont (new java.awt.Font ("Dialog", 0, 12));
    jButton1.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
        jButton1ActionPerformed (evt);
      }
    }
    );


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 4;
    gridBagConstraints1.insets = new java.awt.Insets (10, 0, 25, 0);
    gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
    add (jButton1, gridBagConstraints1);

    jButton2.setText ("Show details");
    jButton2.setFont (new java.awt.Font ("Dialog", 0, 12));
    jButton2.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
        jButton2ActionPerformed (evt);
      }
    }
    );

    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 4;
    gridBagConstraints1.insets = new java.awt.Insets (10, 0, 25, 0);
    gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
    add (jButton2, gridBagConstraints1);

  }//GEN-END:initComponents

  private void jButton2ActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
// Add your handling code here:
    if (showDetails) {
      taPanel.setVisible(false);
      jButton2.setText("Show details");
      showDetails = false;
    }
    else {
      taPanel.setVisible(true);
      jButton2.setText("Hide details");
      showDetails = true;
    }
    frame.doLayout();
    frame.pack();
    frame.validate();    
    frame.repaint();
  }//GEN-LAST:event_jButton2ActionPerformed

  public void updateProp() {
    File file = new File(propName);
    if (file.exists()) {
      try {
        details.setText("");
        BufferedReader reader = new BufferedReader(new FileReader(file));
        String line = null;
        while ((line = reader.readLine()) != null) 
          details.append(line + "\n");
      }
      catch (IOException e) { 
        System.out.println(e);
        details.setText("");
        details.append(e.toString());
      }
    }
  }
  
  private void jButton1ActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
// Add your handling code here:
    setObjectView();
  }//GEN-LAST:event_jButton1ActionPerformed

  private void jTextField1ActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
// Add your handling code here:
    setObjectView();
  }//GEN-LAST:event_jTextField1ActionPerformed


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JComboBox jComboBox1;
  private javax.swing.JTextField jTextField1;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JButton jButton1;
  private javax.swing.JButton jButton2;
  // End of variables declaration//GEN-END:variables

  private javax.swing.JComboBox box2;
  private AceDBFrame dbFrame = null;
  private Properties viewProp = null;
  private JFrame frame = null;
  private JTextArea details = null;
  private JPanel taPanel = null;
  private boolean showDetails = false;
  private final String propName = "jadex" + File.separator + "view.prop";
  
  private void setObjectView() {
    
    //if (jTextField1.getText().length() == 0) return;
          
    viewProp = new Properties();
    String classe = jComboBox1.getSelectedItem().toString();
    //String viewClassName = jTextField1.getText();
	String viewClassName = box2.getSelectedItem().toString();
    try {
      File file = new File(propName);
      if (!file.exists()) file.createNewFile();
      FileInputStream fis = new FileInputStream(file);
      //FileOutputStream fos = new FileOutputStream(file);
      viewProp.load(fis);
      viewProp.setProperty(classe, viewClassName);
      FileOutputStream fos = new FileOutputStream(file);
      viewProp.store(fos, null);
      fis.close();
      fos.close();
      updateProp();
     }
    catch (IOException e) { 
      jTextField1.setText("Cannot set the view class.");
      jTextField1.requestFocus();
    }
    return ;
  }
  
  public void setDbFrame(AceDBFrame newValue) {
	this.dbFrame = newValue;
	//Feed the data to the class JComboBox.
	java.util.Vector v = newValue.getNames();
	for (int i = 0; i < v.size(); i++) 
		jComboBox1.addItem(v.elementAt(i));
}

public AceDBFrame getDbFrame() { return dbFrame; }
  
  public static void main(java.lang.String[] args) {
    ViewSettingPanel panel = new ViewSettingPanel();
   }
}