/*
 * DumpView.java
 *
 * Created on July 6, 2000, 11:22 AM
 */

package jadex.swing.classView;

import jade.db.*;

import javax.swing.*;
/**
 * This is a simple AceObject view. The content of the AceObject will be dumped into a
 * JTextArea by using Tab for good-looking. There are no cross-linkings for contained
 * AceObjects.
 * @author  wgm
 * @version
 */
public class DumpClassView extends ClassView {

    private AceObject localObj = null; // The AceObect to be dislayed.
    private JComponent view = null; // The Component for displaying AceObject.

    /** Default constructor.*/
    public DumpClassView() {
    }

    /** Set the AceObject to be displayed.
    * @param obj the AceObject to be displayed.
    */
    public void setObject(AceObject obj) {
        localObj = obj;
        JTextArea ta = new JTextArea();
        ta.setText(localObj.dump());
        ta.setEditable(false);
        setView(new JScrollPane(ta));
    }

    /** Get the AceObject displayed.
    * @return the displayed AceObject.
    */
    public AceObject getObject() {
        return localObj;
    }

    /** Get the JComponent displaying the AceObject.
    * @return the JComponent displaying the AceObject.
    */
    public JComponent getView() {
        return view;
    }

    /** Set the JComponent for displaying the AceObject.
    * @param comp the JComponenet for displaying the AceObject.
    */
    public void setView(JComponent comp) {
        this.view = comp;
    }
}