/*
 * MapView.java: GeneticMap View. This class is not a good design, and should be changed in the future.
 *
 * Created on July 18, 2000, 7:53 PM
 */

package jadex.swing.classView;

import javax.swing.*;
import jadex.swing.map.*;
import jadex.swing.*;
import java.awt.*;
import java.awt.event.*;
import jade.db.*;
import java.util.*;
import javax.swing.border.*;

import java.applet.*;
/**
 * This MapView is used to display Genetic_map. Please note: <em>This is not the MapView
 * for SequenceMap or SequenceView</em>. For SequenceMap, use {@link SequenceMapView SequenceMapView}
 * class. For SequenceView, use {@link SequenceView SequenceView} class.
 * @author  wgm
 * @version 1.0
 */
public class MapView extends ClassView {

    private AceObject map = null; // The AceObject to be displayed.
    private JComponent view = null; // The JComponent displaying the AceObject.
    private MapRange range = new MapRange(-30.0f, 30.0f); // Default maximum MapRange.
    private JFrame f = null; // The JFrame hoding this classView.
    private String title = new String("Map View: "); // Title of this map view.

    private boolean debug = false; // Flag to control debug mode.

    // All these variables are for GUI
    private LocusShow lc = null; // The display for the loci.
    private JPanel lcPanel = null; // The JPanel for holding LocusShow.
    private IntervalContainer ic = null; // The Interval display.
    private JPanel itPanel = null; // JPanel for holding Interval display.
    private JSplitPane split = null; // Holding lcPanel and itPanel.
    private LocusPanel marker = null; // holding all markers
    private JPanel markerPanel = null; // holding marker locusshow.
    private JPanel solid1 = null; // A lelp Panel for layout purpose.
    private MapCartoon locator = null; // For zooming displaying.
    private JPanel locatorPanel = null; // Holding locator.
    private JPanel scalePane1, scalePane2; // Left and right MapScales for displaying the Zoomed range.
    private RangeControlPanel rangeControl = null; // For zooming buttons, specifying a range and reset.

    private MapControl control = null; // Play the central control role

    // One more GUI variable
    private MapMenuBar menubar = null;
    // A flag to indicate if this mapview is in an applet
    private boolean isApplet = false;

    /** Default constructor.
    */
    public MapView() {
        initialize();
    }

    /** An overloaded constructor.
    * @param o the AceObject to be displayed.
    * @exception If this AceObject is not a genetic_map class, throw a classCastException.
    */
    public MapView(AceObject o) throws ClassCastException {
        initialize();
        setObject(o);
    }

    /** Another constructor for applet 
    * @param o the AceObject to be displayed.
    * @param a the Applet this MapView is in.
    * @exception If this AceObject is not a genetic_map class, throw a classCastException.
    */
    public MapView(AceObject o, Applet a) throws ClassCastException {
        OpenFrames.getInstance().setApplet(a);
        isApplet = true;
        initialize();
        setObject(o);
    }

    /** Set the AceObject to be displayed.
    * @param object the AceObject to be displayed.
    */
    public void setObject(AceObject object) {

        if (!(object.classe().equalsIgnoreCase("map"))) {
            System.err.println("AceObject is not a map");
            throw new ClassCastException("No Map Class");
        }
        if (debug) System.out.println(object.classe() + " " + object.name());
        this.map = object;
        setMarker();
        setLocus();
        setInterval();
        setFrame();
        f.setTitle("Map View: " + map.classe() + " " + map.name());
    }

    /** Initialize the JFrame.
    */
    private void initialize() {
        f = new JFrame(title);
        menubar = new MapMenuBar(this);
        menubar.showFullMenu(false);
        f.setJMenuBar(menubar);
        f.setSize(800, 600);
        control = new MapControl(range);
    }

    //public void setApplet(Applet a) {
    //  if (rangeControl != null) rangeControl.setApplet(a);
    //}

    /** Set the JFrame's title.
    * @param t the title for the JFrame.
    */
    public void setTitle (String t) {
        this.title = t;
        f.setTitle(t);
    }

    /** Setup the JFrame. The method name should be changed to SetupFrame.
    * This is a very bad method, and serveral other methods should be refactored out.
    * Basically, this method initializes all displays and layouts them.
    */
    public void setFrame() {

        //The parent panel holding all these panels
        JPanel pane = new JPanel();
        pane.setLayout(new BoxLayout(pane, BoxLayout.X_AXIS));
        pane.setBorder(BorderFactory.createRaisedBevelBorder());

        //Adding the marker
        markerPanel = new JPanel();
        markerPanel.setLayout(new BorderLayout());
        markerPanel.add(getLabel("Marker"), "North");
        markerPanel.add(getLabel("Marker"), "South");
        marker.setPreferredSize(new Dimension(50, 500));
        marker.setBorder(BorderFactory.createEtchedBorder());
        markerPanel.add(marker, "Center");
        //pane.add(markerPanel);

        //Adding the mapcartoon
        locator = new MapCartoon(range);
        locatorPanel = new JPanel();
        locatorPanel.setLayout(new BorderLayout());
        locatorPanel.add(getLabel("Locator"), "North");
        locatorPanel.add(getLabel("Locator"), "South");
        //locator.setPreferredSize(new Dimension(40, 500));
        locator.setBorder(BorderFactory.createEtchedBorder());
        locator.setMapControl(control);
        locatorPanel.add(locator, "Center");
        //pane.add(pp1);

        //Adding a solid panel
        JPanel solid = new JPanel();
        solid.setLayout(new BoxLayout(solid, BoxLayout.Y_AXIS));
        solid.setBorder(BorderFactory.createRaisedBevelBorder());
        solid1 = new JPanel();
        solid1.setLayout(new GridLayout(1, 2));
        solid1.setPreferredSize(new Dimension(90, 300));
        solid1.add(markerPanel);
        solid1.add(locatorPanel);
        Component blank1 = Box.createVerticalGlue();
        Component blank2 = Box.createVerticalGlue();
        rangeControl = new RangeControlPanel();
        rangeControl.setBorder(BorderFactory.createEtchedBorder());
        rangeControl.setPreferredSize(new Dimension(90, 120));
        solid.setSize(90, 500);
        solid.add(solid1);
        solid.add(blank1);
        solid.add(rangeControl);
        solid.add(blank2);
        pane.add(solid);
        //Linking RangeControlPanel to MapControl
        rangeControl.setMapControl(control);

        //Adding the left mapscale
        MapScale1 p4 = new MapScale1();
        p4.setRange(range);
        p4.setPreferredSize(new Dimension(50, 500));
        p4.setBorder(BorderFactory.createEtchedBorder());
        scalePane1 = new JPanel();
        scalePane1.setLayout(new BorderLayout());
        scalePane1.add(getLabel("Scale"), "North");
        scalePane1.add(getLabel("Scale"), BorderLayout.SOUTH);
        scalePane1.add(p4, BorderLayout.CENTER);
        pane.add(scalePane1);

        //Adding the interval panel
        itPanel = new JPanel();
        itPanel.setLayout(new BorderLayout());
        itPanel.add(getLabel("Intervals"), "North");
        itPanel.add(getLabel("Intervals"), "South");
        ic.setBorder(BorderFactory.createEtchedBorder());
        JScrollPane sp = new JScrollPane(ic);
        //JPopupMenu pop2 = new ZoomPopupMenu((MapZoom) ic, f);
        //ic.setPopup(pop2);
        sp.setPreferredSize(new Dimension(400, 500));
        itPanel.add(sp, "Center");
        //pane.add(pp2);

        //Adding the locus panel
        lcPanel = new JPanel();
        lcPanel.setLayout(new BorderLayout());
        lcPanel.add(getLabel("Loci"), "North");
        lcPanel.add(getLabel("Loci"), "South");
        lc.setBorder(BorderFactory.createEtchedBorder());
        JScrollPane plc = new JScrollPane(lc);
        plc.setPreferredSize(new Dimension(400, 500));
        lcPanel.add(plc);
        //pane.add(pp3);

        //Adding a splitpane
        split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, itPanel, lcPanel);
        //split.setDividerLocation(0.50);
        split.setDividerSize(5);
        JPanel splitP = new JPanel();
        splitP.setLayout(new BorderLayout());
        splitP.add(split, "Center");
        split.setBorder(BorderFactory.createEtchedBorder());
        pane.add(splitP);

        //Adding the right mapscale
        MapScale1 p41 = new MapScale1();
        p41.setRange(range);
        p41.setPreferredSize(new Dimension(50, 500));
        p41.setBorder(BorderFactory.createEtchedBorder());
        scalePane2 = new JPanel();
        scalePane2.setLayout(new BorderLayout());
        scalePane2.add(getLabel("Scale"), "North");
        scalePane2.add(getLabel("Scale"), BorderLayout.SOUTH);
        scalePane2.add(p41, BorderLayout.CENTER);
        pane.add(scalePane2);

        setView(new JScrollPane(pane));

        //layouting this frame
        f.getContentPane().removeAll();
        f.getContentPane().add(new JScrollPane(pane), "Center");
        f.validate();
        f.setVisible(true);

        //Linking property change listener
        control.addPropertyChangeListener(p4);
        control.addPropertyChangeListener(lc.getLocusControl());
        control.addPropertyChangeListener(ic);
        control.addPropertyChangeListener(p41);
        control.addPropertyChangeListener(locator);

        // Setting the control for lc and oc
        lc.getLocusControl().setMapControl(control);
        ic.setMapControl(control);

        menubar.showFullMenu(true);
        split.setDividerLocation(0.50);

    }

    /** A utility to construct a JLabel for marking the Panels.
    * @param label the text content.
    * @return the formatted JLabel containing the text label.
    */
    private JLabel getLabel(String label) {
        JLabel n1 = new JLabel(label);
        n1.setBorder(BorderFactory.createEtchedBorder());
        n1.setForeground(Color.black);
        n1.setHorizontalAlignment(JLabel.CENTER);
        n1.setFont(new Font("Dialog", 0, 10));
        return n1;
    }

    /** Set the Marker Panel contents.
    */
    public void setMarker() {
    String[] params = {map.name()};
        Object[][] markers = map.getTable("Map.marker", "Map.marker", params, "kf");
        //System.out.println(markers.length);
        setMarker(markers);
    }

    /** Set the marker Panel contents by using data from Array loci.
     * @param loci the marker data.
    */
    public void setMarker(Object[][] loci) {
        marker = new LocusPanel(range);

        for (int i = 0; i < loci.length; i++) {
            //System.out.println(loci[i][0]+ "     " + loci[i][1]);
            String name = null;
            AceObject locus = null;
            try {
                locus = (AceObject) loci[i][0];
                name = locus.name();
                if (debug) System.out.println(name);
            }
            catch (Exception e) {
                if (debug) System.out.println("MapView SetLocus(): " + e);
                name = (String) loci[i][0];
            }
            Float position = (Float) loci[i][1];
            float pos = position.floatValue();
            LocusUI ui = new LocusUI(name, pos);
            ui.setHorizontalAlignment(JLabel.RIGHT);
            if (debug) System.out.println(locus.name() + "     " + pos);
            if (locus != null) ui.setAceObject(locus);
            marker.addLocus(ui);
        }
    }

    /** Control if the marker should be displayed.
    * @param show true, show Marker; false, turn off marker.
    */
    public void showMarker(boolean show) {
        if ((markerPanel != null) && (solid1 != null)) {
            markerPanel.setVisible(show);
        }
    }

    /** Control if the locator should be displayed.
     * @param show true, show locator; false, turn off locator.
    */
    public void showLocator(boolean show) {
        if (locator != null) locatorPanel.setVisible(show);
    }

    /** Control if the Mapscale on the left should be displayed.
    * @param show true, on; false, off.
    */
    public void showLeftScale(boolean show) {
        if (scalePane1 != null) {
            scalePane1.setVisible(show);
            //f.validate();
        }
    }

    /** Control if the MapScale on the right should be displayed.
    * @param show true, on; false, off.
    */
    public void showRightScale(boolean show) {
        if (scalePane2 != null) {
            scalePane2.setVisible(show);
            //f.validate();
        }
    }

    /** Set the Locus display.
    */
    public void setLocus() {

    String[] params = {map.name()};
        Object[][] loci = map.getTable("Map.point", "Map.point", params, "kff");
        if (debug) System.out.println(loci.length);
        /*
        for (int i = 0; i < loci.length; i++) {
        AceObject o = (AceObject) loci[i][0];
        System.out.print(o.name() + "     ");
        System.out.print(loci[i][1] + "     ");
        System.out.println(loci[i][2]);
        }*/
        setLocus(loci);
    }

    /** Control if the Locus Panel should be displayed or not.
    * @param show true, on; false, off.
    */
    public void showLocus(boolean show) {
        if (lcPanel != null) {
            lcPanel.setVisible(show);
            if (show) split.setDividerLocation(0.50);
            //f.validate();
        }
    }

    /** Set the Locus display by using data from loci.
    * @param loci the data to be used for locus display.
    */
    public void setLocus(Object[][] loci) {
        //lc = new LocusContainer(range);
        lc = new LocusDisplay(range);
        DisplayModel lm = new DisplayModel();

        for (int i = 0; i < loci.length; i++) {
            String name = null;
            AceObject locus = null;
            try {
                locus = (AceObject) loci[i][0];
                name = locus.name();
                if (debug) System.out.println(name);
            }
            catch (Exception e) {
                if (debug) System.out.println("MapView SetLocus(): " + e);
                name = (String) loci[i][0];
            }
            Float position = (Float) loci[i][1];
            float pos = position.floatValue();
            if (debug) System.out.println(pos);
            Float error = (Float) loci[i][2];
            float err = error.floatValue();
            if (debug) System.out.println(err);
            MapPoint p = new Locus(name, pos, err, locus);

            if (debug) System.out.println(locus.name() + "     " + pos);
            //if (locus != null) ui.setAceObject(locus);
            lm.addPoint(p);
        }
        lm.sortByError();
        lc.setModel(lm);
    }

    /** Create the intervalContainer.
    */
    public void setInterval() {

    String[] params = {map.name()};
        Object[][] intervals = map.getTable("Map.interval", "Map.interval", params, "kff");
        if (debug) System.out.println(intervals.length);

        setInterval(intervals);
    }

    /** Display intervalContainer or not.
    * @param show true, on; false, off.
    */
    public void showInterval(boolean show) {
        if (itPanel != null) {
            itPanel.setVisible(show);
            if (show) split.setDividerLocation(0.50);
            //f.validate();
        }
    }

    /** Set up the data and create the intervalContainer.
     * @param interals the data to be used for setup the intercalcontainer.
    */
    public void setInterval(Object[][] intervals) {
        ic = new IntervalContainer(range);
        for (int i = 0; i < intervals.length; i++) {
            String name = null;
            AceObject interval = null;
            try {
                interval = (AceObject) intervals[i][0];
                name = interval.name();
            }
            catch (Exception e) {
                //System.out.println("MapView setInterval(): " + e);
                name = (String) intervals[i][0];
            }
            Float start = (Float) intervals[i][1];
            float s = start.floatValue();
            Float end = (Float) intervals[i][2];
            float e = end.floatValue();
            IntervalUI ui = new IntervalUI(s, e, name);
            //if (debug) System.out.println(interval.name() + "     " + s + "     " + e);
            if (interval != null) ui.setAceObject(interval);
            ic.addInterval(ui);
        }
    }

    /** Get the Aceobject displayed.
    * @return the displayed AceObject.
    */
    public AceObject getObject() {
        return this.map;
    }

    /** Get the JComponent for displaying the AceObject.
    * @return the JComponent displaying the AceObject.
    */
    public JComponent getView() {
        return this.view;
    }

    /** Get the JFrame holding all these displays.
    * @return the JFrame holding all these displays.
    */
    public JFrame getViewFrame() {
        return this.f;
    }

    /** Set the JComponent for displaying the AceObject.
    * @param comp the JComponent displaying the AceObject.
    */
    public void setView(JComponent comp) {
        this.view = comp;
    }

    /** See if this MapView is in an applet or not.
    * @return true, in an applet; false, not in an applet.
    */
    public boolean isApplet() { 
        return isApplet; 
    }

    /** Search Intercal or Locus by their names.
    * @param cls the class to be searched, either Intercal or Locus.
    * @param pattern the searching key.
    */
    public void search(String cls, String pattern) {
        if (cls.equalsIgnoreCase("locus")) lc.doSearch(pattern);
        else if (cls.equalsIgnoreCase("rearrangement")) ic.doSearch(pattern);
    }

    /** A test method for this MapView. */
    public static void main(String[] args) {
        MapView view = new MapView();
        JFrame f = view.getViewFrame();
        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
        f.setVisible(true);
    }
}
