/*
 * AbstractAcePoint.java
 *
 * Created on July 27, 2000, 9:47 AM
 */

package jadex.swing.map;

/**
 * Default implementation of MapPoint.
 * @author  wgm
 * @version
 */
public class AbstractMapPoint implements MapPoint {

    private String name = null; // The name of the MapPoint.
    private float position = Float.MAX_VALUE; // The default position.

    /** Default constructor. */
    public AbstractMapPoint() {
    }

    /** An overloaded construcor.
    * @param name the name of the MapPoint.
    * @param pos the position of the MapPoint
    */
    public AbstractMapPoint(String name, float pos) {
        this.name = name;
        this.position = pos;
    }

    /** Get the name of this MapPoint.
    * @return the name of this MapPoint.
    */
    public String getName() {
        return name;
    }
    
    /** Get the position of this MapPoint.
     * @return this position of this MapPoint.
    */
    public float getPosition() throws UnknownPositionException {
        if (position == Float.MAX_VALUE) throw new UnknownPositionException();
        else return position;
    }

    /** Set the name of this MapPoint.
    * @param name the name of this MapPoint.
    */
    public void setName(String name) {
        this.name = name;
    }

    /** Set the position of this MapPoint.
    * @param position the position of this MapPoint.
    */
    public void setPosition(float position) {
        this.position = position;
    }

    /** Set the error of the position. Do nothin in this implementation.
    */
public void setError(float err) {}

/** Get the error of this position. Get 0.0 as the default value.
*/
public float getError() { return 0.0f; }
}