/*
 * HelpTextPane.java
 *
 * Created on August 24, 2000, 4:42 PM
 */

package jadex.swing.map;


import java.io.*;
import java.awt.*;
import javax.swing.*;


/**
 * This is a JEditorPane to display a help HTML file for the MapView.
 * @author  wgm
 * @version 1.0
 */
public class HelpPane extends JEditorPane {

    /** Creates new HelpTextPane */
    public HelpPane() {
        initialize(false);
    }

    /** Another constructor to be used in applet.
    * @param isApplet true, if in the applet.
     */
    public HelpPane(boolean isApplet) {
        initialize(isApplet);
    }

    /** Initialize all GUI.
    */
    private void initialize(boolean isApplet) {
        super.setContentType("text/html");
        super.setEditable(false);
        super.setFont(new Font("dialog", 0, 10));
        readHelp(isApplet);
    }

    /** Get the hekp file.
    */
    private void readHelp(boolean isApplet) {
        try {
            File helpFile = null;
            InputStreamReader reader = null;
            if (!isApplet) {
                helpFile = new File("help.html");
                reader = new FileReader(helpFile);
            }
            else {
                InputStream input = getClass().getResourceAsStream("help.html");
                reader = new InputStreamReader(input);

            }
            super.read(reader, new String("text/html"));
        }
        catch (IOException e) {
            super.setText(e.toString());
        }
    }
}