package jadex.swing.map;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.awt.geom.*;
import java.util.*;

/** This is another way to display loci. It should be deprecated. However, it is
* still used in Marker display in the MapView.
* @author wgm
* @version 1.0
 */

public class LocusPanel extends JPanel {

    Vector loci = null; // Data to be displayed.
    private float DIFF = 10.0f; // the distance between two locusUI.
    private float REL = 5.0f; // The ratio
    private MapRange range = null; // The currently diplayed MapRange.
    private float extend; // The extend of the MapRange.
    private float offset = 0.0f; // The margin for displaying.

    /** Default constructor.
    */
    public LocusPanel() {
        this.setLayout(null);
        this.setPreferredSize(new Dimension(40, 100));
        loci = new Vector();
    }

    /** Overloaded constructor.
    * @param map the displaying MapRange.
    */
    public LocusPanel(MapRange map) {
        this();
        setRange(map);
    }

    /** Set the dispplaying maprange.
    * @param r the maprange to be displayed.
    */
    public void setRange(MapRange r) {
        this.range = r;
        try {
            offset = range.getEndF();
            extend = range.getExtendF();
        }
    catch (UnknownPositionException e) { System.out.println("Cannot get scale"); }
        repaint();
    }


    /** Add an individual LocusUI.
    * @param l an individualUI to be added.
    */
    public void addLocus(LocusUI l) {
        if (checkAdding(l)) {
            loci.addElement(l);
            add(l);
        }
    }

    //public Dimension getPreferredSize() {
    // return new Dimension(40, 400);
    //}

    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Dimension2D d = (Dimension2D) getSize();
        float w = (float) d.getWidth();
        float h = (float) d.getHeight();

        Graphics2D g2d = (Graphics2D) g;
        g2d.setColor(Color.white);
        g2d.fill(new Rectangle2D.Float(0.0f, 0.0f, w, h));

        LocusUI ui = null;
        float rel =  h / extend;
        for (int i = 0; i < loci.size(); i++) {
            ui = (LocusUI) loci.elementAt(i);
            int position = (int) ((offset-ui.getPosition()) * rel);
            ui.setBounds(0, position, (int) w, 10);
        }
    }


    /** Check if a LocusUI can be added.
    * @param ui the LocusUI to be added.
    * @retur true for being able to be added.
    */
    public boolean checkAdding(LocusUI ui) {
        boolean canBeAdded = true;
        LocusUI l = null;
        int size = loci.size();
        float uiPosition = ui.getPosition();
        float diff;

        for (int i = 0; i < size; i++) {
            l = (LocusUI) loci.elementAt(i);
            diff = Math.abs(l.getPosition() - uiPosition);
            if (diff*REL <= DIFF) {
                //System.out.println(ui.getName() + " cannot be added." + diff + " " + REL);
                return false;
            }
        }
        return canBeAdded;
    }
}