/*
 * AcePoint.java
 *
 * Created on July 27, 2000, 9:26 AM
 */

package jadex.swing.map;

/**
 * This is the specification for objects which can be displayed in the LocusDisplay.
 * @author  wgm
 * @version
 */
public interface MapPoint {

    /** The name of the MapPoint.
    * @return the name of the MapPoint.
    */
    public String getName();

    /** Get the position of this MapPoint.
    * @return the position of this mappoint.
    * @exception throw an UnknownPositionException if the positon is unknown.
    */
    public float getPosition()throws UnknownPositionException;

    /** Set the name of the mappoint.
    * @paran name the name of the mappoint.
    */
    public void setName(String name);

    /** Set the position of the MapPoint.
    * @param position the position of the MapPoint.
    */
    public void setPosition(float position);

    /** Set the error of the position of this MapPoint.
    * @param err the error of the position
    */
    public void setError(float err);

    /** Get the error of the position of this MapPoint.
    * @return the error of the position of the MapPoint.
    */
    public float getError();
}