/*
 * RangeControlPanel.java
 *
 * Created on August 2, 2000, 4:50 PM
 */

package jadex.swing.map;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
/**
 * This customized JPanel is used to set the displayed MapRange, i.e., zooming function.
 * @author  wgm
 * @version 1.0
 */
public class RangeControlPanel extends javax.swing.JPanel {

    // The central MapControl.
    private MapControl control = null;

    /** Creates new form RangeControlPanel */
    public RangeControlPanel() {
        initComponents ();
        addAction();
    }

    /** Set the central MapControl to coordinate all zooming activities.
    */
    public void setMapControl(MapControl c) {
        this.control = c;
        zoomButtons.setMapControl(control);
    }

    /** Initialize GUIs. */
    private void initComponents () {
        jPanel1 = new javax.swing.JPanel ();
        jLabel1 = new javax.swing.JLabel ();
        jLabel2 = new javax.swing.JLabel ();
        jTextField1 = new javax.swing.JTextField ();
        jLabel3 = new javax.swing.JLabel ();
        jTextField2 = new javax.swing.JTextField ();
        jButton4 = new javax.swing.JButton ();
        jPanel2 = new javax.swing.JPanel ();
        jButton3 = new javax.swing.JButton ();
        setLayout (new java.awt.BorderLayout ());
        setPreferredSize (new java.awt.Dimension(90, 120));
        setMinimumSize (new java.awt.Dimension(90, 120));

        jPanel1.setLayout (new java.awt.GridBagLayout ());
        java.awt.GridBagConstraints gridBagConstraints2;
        jPanel1.setBorder (new javax.swing.border.EtchedBorder());

        jLabel1.setText ("Setting Range");
        jLabel1.setFont (new java.awt.Font ("Dialog", 0, 10));

        gridBagConstraints2 = new java.awt.GridBagConstraints ();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 0;
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.insets = new java.awt.Insets (0, 0, 5, 0);
        jPanel1.add (jLabel1, gridBagConstraints2);

        jLabel2.setText ("Start:");
        jLabel2.setFont (new java.awt.Font ("Dialog", 0, 10));

        gridBagConstraints2 = new java.awt.GridBagConstraints ();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.insets = new java.awt.Insets (0, 0, 5, 0);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add (jLabel2, gridBagConstraints2);


        gridBagConstraints2 = new java.awt.GridBagConstraints ();
        gridBagConstraints2.gridx = 1;
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.insets = new java.awt.Insets (0, 0, 5, 0);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.EAST;
        jPanel1.add (jTextField1, gridBagConstraints2);

        jLabel3.setText ("End:");
        jLabel3.setFont (new java.awt.Font ("Dialog", 0, 10));

        gridBagConstraints2 = new java.awt.GridBagConstraints ();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.gridy = 2;
        gridBagConstraints2.insets = new java.awt.Insets (0, 0, 5, 0);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add (jLabel3, gridBagConstraints2);


        gridBagConstraints2 = new java.awt.GridBagConstraints ();
        gridBagConstraints2.gridx = 1;
        gridBagConstraints2.gridy = 2;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.insets = new java.awt.Insets (0, 0, 5, 0);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.EAST;
        jPanel1.add (jTextField2, gridBagConstraints2);

        jButton4.setText ("OK");
        jButton4.setFont (new java.awt.Font ("Dialog", 0, 10));

        gridBagConstraints2 = new java.awt.GridBagConstraints ();
        gridBagConstraints2.gridy = 3;
        gridBagConstraints2.gridwidth = 2;
        jPanel1.add (jButton4, gridBagConstraints2);


        add (jPanel1, java.awt.BorderLayout.CENTER);


        jButton3.setText ("Reset");
        jButton3.setFont (new java.awt.Font ("Dialog", 0, 10));

        jPanel2.add (jButton3);


        add (jPanel2, java.awt.BorderLayout.SOUTH);

        if (zoomButtons == null) zoomButtons = new ZoomButtonControl();
        zoomButtons.setBorder(BorderFactory.createEtchedBorder());
        add(zoomButtons, java.awt.BorderLayout.NORTH);

    }

    /** Add actionlistenes to the buttons.
    */
    public void addAction() {
        ActionListener l1 = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (control != null) {
                    MapRange map = control.getMap();
                    control.setRange(map);
                }
            }
        };
        ActionListener l2 = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (control != null) {
                    float start = Float.parseFloat(jTextField1.getText());
                    float end = Float.parseFloat(jTextField2.getText());
                    if (start > end) {
                        jTextField1.setText(end + "");
                        jTextField2.setText(start + "");
                        float temp = start;
                        start = end;
                        end = temp;
                    }
                    MapRange range = new MapRange(start, end);
                    control.setRange(range);
                }
            }
        };
        jButton3.addActionListener(l1);
        jButton4.addActionListener(l2);
    }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel jPanel1;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JTextField jTextField1;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JTextField jTextField2;
  private javax.swing.JButton jButton4;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JButton jButton3;
  // End of variables declaration//GEN-END:variables
private ZoomButtonControl zoomButtons;

public static void main(String[] args) {
    JFrame f = new JFrame();
    JPanel p = new RangeControlPanel();
    f.setSize(100, 120);
    //f.pack();
    f.getContentPane().add(p, "Center");
    f.addWindowListener(new WindowAdapter() {
    public void windowClosing(WindowEvent e) { System.exit(0); }
    });
    f.setVisible(true);
}
}
