/*
 * CloneOpenFileAction.java: Open a sequnece_map file
 *
 * Created on October 25, 2000, 7:47 PM
 */

package jadex.swing.sequence;

import java.awt.event.*;
import javax.swing.*;

import jadex.swing.classView.*;
import jadex.swing.map.*;
/**
 * This class is used to open a sequnece_map file.
 * @author  wgm
 * @version 1.0
 */
public class CloneOpenFileAction implements ActionListener {

    MapViewContainer container = null; // The container clone display will be added
    SequenceMapView view = null; // Sequence Map View
    
    /** Default constructor */
    public CloneOpenFileAction() {
    }
    
    /** Second constructor with container as the argument */
    public CloneOpenFileAction(MapViewContainer container) {
        this.container = container;
    }

    /** Third constructor with container and SequenceMapView as the arguments */
    public CloneOpenFileAction(MapViewContainer c, SequenceMapView v) {
        setContainer(c);
        setMapView(v);
    }
    
    /** Set MapViewContainer */
    public void setContainer(MapViewContainer c) {
        this.container = c;
    }
    
    /** set SequenceMapView */
    public void setMapView(SequenceMapView v) {
        this.view = v;
    }
    
    public void actionPerformed(final java.awt.event.ActionEvent p1) {
        if (container == null) return;
        JFileChooser chooser = new JFileChooser("/forte4j/Development");
        int returnVal = chooser.showOpenDialog(container);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            java.io.File file = chooser.getSelectedFile();
            String full = file.getAbsolutePath();
            CloneFetcher fetcher = new FileCloneFetcher(full);
            fetcher.fetchClone(); // Fetch all information on sequence_map
            MapRange r = fetcher.getMapScale(); // get the total scale of sequence_map
            CloneDisplay display = new CloneDisplay();
            CloneControl control = new CloneControl(display);
            display.setRange(r);
            control.setCloneFetcher(fetcher);
            control.setMapRange(r);
            display.setCloneControl(control);
            MapControl mapControl = new MapControl();
            mapControl.setMap(r);
            mapControl.addPropertyChangeListener(control);
            control.setMapControl(mapControl);
            
            String name = fetcher.getMapName();
            container.setTitle(container.getTitle() + name);
            container.showControlPanel(true);
            container.setLeftMapScale(true);
            container.setRightMapScale(true);
            container.setMapControl(mapControl);
            container.addPanel(new String("Clone Display"), display);
        }
    }
}