/*
 * IndividualSequenceView.java: This class is used to link sequence to http://www.wormbase.org in applet or application
 * Please note: this is not a good object-oritented design.
 *
 * Created on December 27, 2000, 2:36 PM
 */

package jadex.swing.sequence;

import javax.swing.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

/**
 * This class is used to link sequence to the Wormbase, http://www.wormbase.org, in an applet or application.
 * Please note: this is not a good object-oritented design.
 * @author  wgm
 * @version 1.0
 */
public class IndividualSequenceView {

    private static JApplet applet = null;
    private static final String target = "sequenceview"; // The name of new browser in applet
    private static final String WORMBASE_SEQ = "http://www.wormbase.org/perl/ace/elegans/seq/sequence?name=";

    /** Set the applet used for SequenceView.
    */
    public static void setApplet(JApplet a) {
        applet = a;
    }

    /** Show the detailed information for the Sequence objects. If the SequenceView is
    * used in an applet, a new browser window will be poped up. If in an application, 
    * a JFrame with JEditorPane will be used to show the page of the Sequence from the wormbase.
    * However, the page display in applications are not good, and is not used in the current version
    * of SequenceView.
    * @param name the name of the Sequence object.
    */
    public static void showSequenceInDetail(String name) {
        if (applet != null) {
            URL url = null;
            try {
                url = new URL(WORMBASE_SEQ + name);
            }
            catch(MalformedURLException e) {
                System.err.println("IndividualSequenceView.showSequenceInDetail(): " + e);
            }
            applet.getAppletContext().showDocument(url, target);
        }
        else {
            JFrame f = new JFrame("Sequence: " + name + " in Wormbase");
            try {
                //JEditorPane pane = new JEditorPane(WORMBASE_SEQ + name);
                JEditorPane pane = new JEditorPane();
                pane.setPage(WORMBASE_SEQ + name);
                f.getContentPane().add(new JScrollPane(pane), BorderLayout.CENTER);
            }
            catch(java.io.IOException e1) {
                System.err.println("SequenceElementTableView.addJButtonForMore(): " + e1);
            }
            f.setSize(600, 400);
            f.setVisible(true);
        }
    }
}