/*
 * SequenceFetcher.java: An interface to get data for sequence model
 *
 * Created on November 25, 2000, 9:05 AM
 */

package jadex.swing.sequence;

import org.jdom.*;

/**
 * This is the interface defining a specification for fetching data for SequenceView.
 * @author  wgm
 * @version 1.0
 */
public interface SequenceFetcher {
    
    /** An xml root element: for a whole chromosome, this should be the chromsome element.
     * However, other kinds of elements can also be returned 
     * @return the root element.
     */
    public Element getRoot();
    
    /** The xml document: based on JDOM documentation, JDOM document is not loaded 
     * in the memory. By returning a document, hopefully, the whole document can be
     * manipluated. However, these operations can also be done by using root.
    * @return the xml document.
     */
    public Document getDocument();
    
    /** The namespace of the root if any.
    * @return the namespace for the root.
    */
    public Namespace getNamespace();
}