/*
 * Zoomable.java
 *
 * Created on September 25, 2000, 2:03 PM
 */

package jadex.swing.util;

import java.awt.geom.*;
import java.awt.*;
import java.awt.event.*;
/**
 * An interface all Zoomable display JPanel should be implemented.
 * @author  Guanming Wu
 * @version 1.0
 */
public interface Zoomable {
    /** How zooming should be implemented. */
    public void doZooming(); 
    
    /** Zoom range should be passed from magnifier to here. 
    After zooming,  zoom should be clear up, i.e., zoom = null */
    public void setZoom(Rectangle2D.Float zoom); 
    
    /** Repaint to show the zoom rectangels.*/
    public void repaint(); 
    
    /** The vertical line position. Only rectangles around this line can
    * be zoomed.
    */
    public float getVerticalPosition(); 
    
    /** Change the cursor for displaying zoomability when the mouse is in 
    * the rectangle.
    */
    public void setCursor(Cursor c);
    
    /** Add a mouseListener. This method is used to add a magnifier to the zoomable. 
    */
    public void addMouseListener(MouseListener l);
    
    /** Add a mouseMotionLister. This method is used to add a magnifier to the zoomable.
    */
    public void addMouseMotionListener(MouseMotionListener l);
}